"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides an AWS Backup vault policy resource.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const exampleVault = new aws.backup.Vault("exampleVault", {});
 * const exampleVaultPolicy = new aws.backup.VaultPolicy("exampleVaultPolicy", {
 *     backupVaultName: exampleVault.name,
 *     policy: pulumi.interpolate`{
 *   "Version": "2012-10-17",
 *   "Id": "default",
 *   "Statement": [
 *     {
 *       "Sid": "default",
 *       "Effect": "Allow",
 *       "Principal": {
 *         "AWS": "*"
 *       },
 *       "Action": [
 * 		"backup:DescribeBackupVault",
 * 		"backup:DeleteBackupVault",
 * 		"backup:PutBackupVaultAccessPolicy",
 * 		"backup:DeleteBackupVaultAccessPolicy",
 * 		"backup:GetBackupVaultAccessPolicy",
 * 		"backup:StartBackupJob",
 * 		"backup:GetBackupVaultNotifications",
 * 		"backup:PutBackupVaultNotifications"
 *       ],
 *       "Resource": "${exampleVault.arn}"
 *     }
 *   ]
 * }
 * `,
 * });
 * ```
 *
 * ## Import
 *
 * Backup vault policy can be imported using the `name`, e.g.
 *
 * ```sh
 *  $ pulumi import aws:backup/vaultPolicy:VaultPolicy test TestVault
 * ```
 */
class VaultPolicy extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["backupVaultArn"] = state ? state.backupVaultArn : undefined;
            inputs["backupVaultName"] = state ? state.backupVaultName : undefined;
            inputs["policy"] = state ? state.policy : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.backupVaultName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'backupVaultName'");
            }
            if ((!args || args.policy === undefined) && !opts.urn) {
                throw new Error("Missing required property 'policy'");
            }
            inputs["backupVaultName"] = args ? args.backupVaultName : undefined;
            inputs["policy"] = args ? args.policy : undefined;
            inputs["backupVaultArn"] = undefined /*out*/;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(VaultPolicy.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing VaultPolicy resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new VaultPolicy(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of VaultPolicy.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === VaultPolicy.__pulumiType;
    }
}
exports.VaultPolicy = VaultPolicy;
/** @internal */
VaultPolicy.__pulumiType = 'aws:backup/vaultPolicy:VaultPolicy';
//# sourceMappingURL=vaultPolicy.js.map