"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * ## Example Usage
 *
 * The following example below creates a CloudFront origin request policy.
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = new aws.cloudfront.OriginRequestPolicy("example", {
 *     comment: "example comment",
 *     cookiesConfig: {
 *         cookieBehavior: "whitelist",
 *         cookies: {
 *             items: ["example"],
 *         },
 *     },
 *     headersConfig: {
 *         headerBehavior: "whitelist",
 *         headers: {
 *             items: ["example"],
 *         },
 *     },
 *     queryStringsConfig: {
 *         queryStringBehavior: "whitelist",
 *         queryStrings: {
 *             items: ["example"],
 *         },
 *     },
 * });
 * ```
 */
class OriginRequestPolicy extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["comment"] = state ? state.comment : undefined;
            inputs["cookiesConfig"] = state ? state.cookiesConfig : undefined;
            inputs["etag"] = state ? state.etag : undefined;
            inputs["headersConfig"] = state ? state.headersConfig : undefined;
            inputs["name"] = state ? state.name : undefined;
            inputs["queryStringsConfig"] = state ? state.queryStringsConfig : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.cookiesConfig === undefined) && !opts.urn) {
                throw new Error("Missing required property 'cookiesConfig'");
            }
            if ((!args || args.headersConfig === undefined) && !opts.urn) {
                throw new Error("Missing required property 'headersConfig'");
            }
            if ((!args || args.queryStringsConfig === undefined) && !opts.urn) {
                throw new Error("Missing required property 'queryStringsConfig'");
            }
            inputs["comment"] = args ? args.comment : undefined;
            inputs["cookiesConfig"] = args ? args.cookiesConfig : undefined;
            inputs["etag"] = args ? args.etag : undefined;
            inputs["headersConfig"] = args ? args.headersConfig : undefined;
            inputs["name"] = args ? args.name : undefined;
            inputs["queryStringsConfig"] = args ? args.queryStringsConfig : undefined;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(OriginRequestPolicy.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing OriginRequestPolicy resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new OriginRequestPolicy(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of OriginRequestPolicy.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === OriginRequestPolicy.__pulumiType;
    }
}
exports.OriginRequestPolicy = OriginRequestPolicy;
/** @internal */
OriginRequestPolicy.__pulumiType = 'aws:cloudfront/originRequestPolicy:OriginRequestPolicy';
//# sourceMappingURL=originRequestPolicy.js.map