"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Use this data source to get a list of cognito user pools.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const selectedRestApi = aws.apigateway.getRestApi({
 *     name: _var.api_gateway_name,
 * });
 * const selectedUserPools = aws.cognito.getUserPools({
 *     name: _var.cognito_user_pool_name,
 * });
 * const cognito = new aws.apigateway.Authorizer("cognito", {
 *     type: "COGNITO_USER_POOLS",
 *     restApi: selectedRestApi.then(selectedRestApi => selectedRestApi.id),
 *     providerArns: selectedUserPools.then(selectedUserPools => selectedUserPools.arns),
 * });
 * ```
 */
function getUserPools(args, opts) {
    if (!opts) {
        opts = {};
    }
    if (!opts.version) {
        opts.version = utilities.getVersion();
    }
    return pulumi.runtime.invoke("aws:cognito/getUserPools:getUserPools", {
        "name": args.name,
    }, opts);
}
exports.getUserPools = getUserPools;
//# sourceMappingURL=getUserPools.js.map