"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides a conditional forwarder for managed Microsoft AD in AWS Directory Service.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = new aws.directoryservice.ConditionalForwader("example", {
 *     directoryId: aws_directory_service_directory.ad.id,
 *     remoteDomainName: "example.com",
 *     dnsIps: [
 *         "8.8.8.8",
 *         "8.8.4.4",
 *     ],
 * });
 * ```
 *
 * ## Import
 *
 * Conditional forwarders can be imported using the directory id and remote_domain_name, e.g.
 *
 * ```sh
 *  $ pulumi import aws:directoryservice/conditionalForwader:ConditionalForwader example d-1234567890:example.com
 * ```
 */
class ConditionalForwader extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["directoryId"] = state ? state.directoryId : undefined;
            inputs["dnsIps"] = state ? state.dnsIps : undefined;
            inputs["remoteDomainName"] = state ? state.remoteDomainName : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.directoryId === undefined) && !opts.urn) {
                throw new Error("Missing required property 'directoryId'");
            }
            if ((!args || args.dnsIps === undefined) && !opts.urn) {
                throw new Error("Missing required property 'dnsIps'");
            }
            if ((!args || args.remoteDomainName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'remoteDomainName'");
            }
            inputs["directoryId"] = args ? args.directoryId : undefined;
            inputs["dnsIps"] = args ? args.dnsIps : undefined;
            inputs["remoteDomainName"] = args ? args.remoteDomainName : undefined;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(ConditionalForwader.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing ConditionalForwader resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new ConditionalForwader(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of ConditionalForwader.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === ConditionalForwader.__pulumiType;
    }
}
exports.ConditionalForwader = ConditionalForwader;
/** @internal */
ConditionalForwader.__pulumiType = 'aws:directoryservice/conditionalForwader:ConditionalForwader';
//# sourceMappingURL=conditionalForwader.js.map