"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Manages [DynamoDB Global Tables V1 (version 2017.11.29)](https://docs.aws.amazon.com/amazondynamodb/latest/developerguide/globaltables.V1.html). These are layered on top of existing DynamoDB Tables.
 *
 * > **NOTE:** To instead manage [DynamoDB Global Tables V2 (version 2019.11.21)](https://docs.aws.amazon.com/amazondynamodb/latest/developerguide/globaltables.V2.html), use the `aws.dynamodb.Table` resource `replica` configuration block.
 *
 * > Note: There are many restrictions before you can properly create DynamoDB Global Tables in multiple regions. See the [AWS DynamoDB Global Table Requirements](http://docs.aws.amazon.com/amazondynamodb/latest/developerguide/globaltables_reqs_bestpractices.html) for more information.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const us_east_1 = new aws.Provider("us-east-1", {region: "us-east-1"});
 * const us_west_2 = new aws.Provider("us-west-2", {region: "us-west-2"});
 * const us_east_1Table = new aws.dynamodb.Table("us-east-1Table", {
 *     hashKey: "myAttribute",
 *     streamEnabled: true,
 *     streamViewType: "NEW_AND_OLD_IMAGES",
 *     readCapacity: 1,
 *     writeCapacity: 1,
 *     attributes: [{
 *         name: "myAttribute",
 *         type: "S",
 *     }],
 * }, {
 *     provider: aws["us-east-1"],
 * });
 * const us_west_2Table = new aws.dynamodb.Table("us-west-2Table", {
 *     hashKey: "myAttribute",
 *     streamEnabled: true,
 *     streamViewType: "NEW_AND_OLD_IMAGES",
 *     readCapacity: 1,
 *     writeCapacity: 1,
 *     attributes: [{
 *         name: "myAttribute",
 *         type: "S",
 *     }],
 * }, {
 *     provider: aws["us-west-2"],
 * });
 * const myTable = new aws.dynamodb.GlobalTable("myTable", {replicas: [
 *     {
 *         regionName: "us-east-1",
 *     },
 *     {
 *         regionName: "us-west-2",
 *     },
 * ]}, {
 *     provider: aws["us-east-1"],
 *     dependsOn: [
 *         us_east_1Table,
 *         us_west_2Table,
 *     ],
 * });
 * ```
 *
 * ## Import
 *
 * DynamoDB Global Tables can be imported using the global table name, e.g.
 *
 * ```sh
 *  $ pulumi import aws:dynamodb/globalTable:GlobalTable MyTable MyTable
 * ```
 */
class GlobalTable extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["arn"] = state ? state.arn : undefined;
            inputs["name"] = state ? state.name : undefined;
            inputs["replicas"] = state ? state.replicas : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.replicas === undefined) && !opts.urn) {
                throw new Error("Missing required property 'replicas'");
            }
            inputs["name"] = args ? args.name : undefined;
            inputs["replicas"] = args ? args.replicas : undefined;
            inputs["arn"] = undefined /*out*/;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(GlobalTable.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing GlobalTable resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new GlobalTable(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of GlobalTable.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === GlobalTable.__pulumiType;
    }
}
exports.GlobalTable = GlobalTable;
/** @internal */
GlobalTable.__pulumiType = 'aws:dynamodb/globalTable:GlobalTable';
//# sourceMappingURL=globalTable.js.map