"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * The AMI resource allows the creation and management of a completely-custom
 * *Amazon Machine Image* (AMI).
 *
 * If you just want to duplicate an existing AMI, possibly copying it to another
 * region, it's better to use `aws.ec2.AmiCopy` instead.
 *
 * If you just want to share an existing AMI with another AWS account,
 * it's better to use `aws.ec2.AmiLaunchPermission` instead.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * // Create an AMI that will start a machine whose root device is backed by
 * // an EBS volume populated from a snapshot. It is assumed that such a snapshot
 * // already exists with the id "snap-xxxxxxxx".
 * const example = new aws.ec2.Ami("example", {
 *     ebsBlockDevices: [{
 *         deviceName: "/dev/xvda",
 *         snapshotId: "snap-xxxxxxxx",
 *         volumeSize: 8,
 *     }],
 *     rootDeviceName: "/dev/xvda",
 *     virtualizationType: "hvm",
 * });
 * ```
 *
 * ## Import
 *
 * `aws_ami` can be imported using the ID of the AMI, e.g.
 *
 * ```sh
 *  $ pulumi import aws:ec2/ami:Ami example ami-12345678
 * ```
 */
class Ami extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["architecture"] = state ? state.architecture : undefined;
            inputs["arn"] = state ? state.arn : undefined;
            inputs["description"] = state ? state.description : undefined;
            inputs["ebsBlockDevices"] = state ? state.ebsBlockDevices : undefined;
            inputs["enaSupport"] = state ? state.enaSupport : undefined;
            inputs["ephemeralBlockDevices"] = state ? state.ephemeralBlockDevices : undefined;
            inputs["hypervisor"] = state ? state.hypervisor : undefined;
            inputs["imageLocation"] = state ? state.imageLocation : undefined;
            inputs["imageOwnerAlias"] = state ? state.imageOwnerAlias : undefined;
            inputs["imageType"] = state ? state.imageType : undefined;
            inputs["kernelId"] = state ? state.kernelId : undefined;
            inputs["manageEbsSnapshots"] = state ? state.manageEbsSnapshots : undefined;
            inputs["name"] = state ? state.name : undefined;
            inputs["ownerId"] = state ? state.ownerId : undefined;
            inputs["platform"] = state ? state.platform : undefined;
            inputs["platformDetails"] = state ? state.platformDetails : undefined;
            inputs["public"] = state ? state.public : undefined;
            inputs["ramdiskId"] = state ? state.ramdiskId : undefined;
            inputs["rootDeviceName"] = state ? state.rootDeviceName : undefined;
            inputs["rootSnapshotId"] = state ? state.rootSnapshotId : undefined;
            inputs["sriovNetSupport"] = state ? state.sriovNetSupport : undefined;
            inputs["tags"] = state ? state.tags : undefined;
            inputs["usageOperation"] = state ? state.usageOperation : undefined;
            inputs["virtualizationType"] = state ? state.virtualizationType : undefined;
        }
        else {
            const args = argsOrState;
            inputs["architecture"] = args ? args.architecture : undefined;
            inputs["description"] = args ? args.description : undefined;
            inputs["ebsBlockDevices"] = args ? args.ebsBlockDevices : undefined;
            inputs["enaSupport"] = args ? args.enaSupport : undefined;
            inputs["ephemeralBlockDevices"] = args ? args.ephemeralBlockDevices : undefined;
            inputs["imageLocation"] = args ? args.imageLocation : undefined;
            inputs["kernelId"] = args ? args.kernelId : undefined;
            inputs["name"] = args ? args.name : undefined;
            inputs["ramdiskId"] = args ? args.ramdiskId : undefined;
            inputs["rootDeviceName"] = args ? args.rootDeviceName : undefined;
            inputs["sriovNetSupport"] = args ? args.sriovNetSupport : undefined;
            inputs["tags"] = args ? args.tags : undefined;
            inputs["virtualizationType"] = args ? args.virtualizationType : undefined;
            inputs["arn"] = undefined /*out*/;
            inputs["hypervisor"] = undefined /*out*/;
            inputs["imageOwnerAlias"] = undefined /*out*/;
            inputs["imageType"] = undefined /*out*/;
            inputs["manageEbsSnapshots"] = undefined /*out*/;
            inputs["ownerId"] = undefined /*out*/;
            inputs["platform"] = undefined /*out*/;
            inputs["platformDetails"] = undefined /*out*/;
            inputs["public"] = undefined /*out*/;
            inputs["rootSnapshotId"] = undefined /*out*/;
            inputs["usageOperation"] = undefined /*out*/;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(Ami.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing Ami resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new Ami(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of Ami.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Ami.__pulumiType;
    }
}
exports.Ami = Ami;
/** @internal */
Ami.__pulumiType = 'aws:ec2/ami:Ami';
//# sourceMappingURL=ami.js.map