"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Manages an EC2 Availability Zone Group, such as updating its opt-in status.
 *
 * > **NOTE:** This is an advanced resource. The provider will automatically assume management of the EC2 Availability Zone Group without import and perform no actions on removal from configuration.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = new aws.ec2.AvailabilityZoneGroup("example", {
 *     groupName: "us-west-2-lax-1",
 *     optInStatus: "opted-in",
 * });
 * ```
 *
 * ## Import
 *
 * EC2 Availability Zone Groups can be imported using the group name, e.g.
 *
 * ```sh
 *  $ pulumi import aws:ec2/availabilityZoneGroup:AvailabilityZoneGroup example us-west-2-lax-1
 * ```
 */
class AvailabilityZoneGroup extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["groupName"] = state ? state.groupName : undefined;
            inputs["optInStatus"] = state ? state.optInStatus : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.groupName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'groupName'");
            }
            if ((!args || args.optInStatus === undefined) && !opts.urn) {
                throw new Error("Missing required property 'optInStatus'");
            }
            inputs["groupName"] = args ? args.groupName : undefined;
            inputs["optInStatus"] = args ? args.optInStatus : undefined;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(AvailabilityZoneGroup.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing AvailabilityZoneGroup resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new AvailabilityZoneGroup(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of AvailabilityZoneGroup.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === AvailabilityZoneGroup.__pulumiType;
    }
}
exports.AvailabilityZoneGroup = AvailabilityZoneGroup;
/** @internal */
AvailabilityZoneGroup.__pulumiType = 'aws:ec2/availabilityZoneGroup:AvailabilityZoneGroup';
//# sourceMappingURL=availabilityZoneGroup.js.map