"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides an EC2 host resource. This allows hosts to be created, updated,
 * and deleted.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const test = new aws.ec2.DedicatedHost("test", {
 *     autoPlacement: "on",
 *     availabilityZone: "us-west-1a",
 *     hostRecovery: "on",
 *     instanceType: "c5.18xlarge",
 * });
 * const testData = test.id.apply(id => aws.ec2.getDedicatedHost({
 *     hostId: id,
 * }, { async: true }));
 * ```
 *
 * ## Import
 *
 * hosts can be imported using the `host_id`, e.g.
 *
 * ```sh
 *  $ pulumi import aws:ec2/dedicatedHost:DedicatedHost host_id h-0385a99d0e4b20cbb
 * ```
 */
class DedicatedHost extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["autoPlacement"] = state ? state.autoPlacement : undefined;
            inputs["availabilityZone"] = state ? state.availabilityZone : undefined;
            inputs["hostRecovery"] = state ? state.hostRecovery : undefined;
            inputs["instanceFamily"] = state ? state.instanceFamily : undefined;
            inputs["instanceType"] = state ? state.instanceType : undefined;
            inputs["tags"] = state ? state.tags : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.availabilityZone === undefined) && !opts.urn) {
                throw new Error("Missing required property 'availabilityZone'");
            }
            inputs["autoPlacement"] = args ? args.autoPlacement : undefined;
            inputs["availabilityZone"] = args ? args.availabilityZone : undefined;
            inputs["hostRecovery"] = args ? args.hostRecovery : undefined;
            inputs["instanceFamily"] = args ? args.instanceFamily : undefined;
            inputs["instanceType"] = args ? args.instanceType : undefined;
            inputs["tags"] = args ? args.tags : undefined;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(DedicatedHost.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing DedicatedHost resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new DedicatedHost(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of DedicatedHost.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === DedicatedHost.__pulumiType;
    }
}
exports.DedicatedHost = DedicatedHost;
/** @internal */
DedicatedHost.__pulumiType = 'aws:ec2/dedicatedHost:DedicatedHost';
//# sourceMappingURL=dedicatedHost.js.map