"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides details about a specific EC2 Customer-Owned IP Pool.
 *
 * This data source can prove useful when a module accepts a coip pool id as
 * an input variable and needs to, for example, determine the CIDR block of that
 * COIP Pool.
 *
 * ## Example Usage
 *
 * The following example returns a specific coip pool ID
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const config = new pulumi.Config();
 * const coipPoolId = config.requireObject("coipPoolId");
 * const selected = aws.ec2.getCoipPool({
 *     id: coipPoolId,
 * });
 * ```
 */
function getCoipPool(args, opts) {
    args = args || {};
    if (!opts) {
        opts = {};
    }
    if (!opts.version) {
        opts.version = utilities.getVersion();
    }
    return pulumi.runtime.invoke("aws:ec2/getCoipPool:getCoipPool", {
        "filters": args.filters,
        "localGatewayRouteTableId": args.localGatewayRouteTableId,
        "poolId": args.poolId,
        "tags": args.tags,
    }, opts);
}
exports.getCoipPool = getCoipPool;
//# sourceMappingURL=getCoipPool.js.map