import * as pulumi from "@pulumi/pulumi";
import { input as inputs, output as outputs } from "../types";
/**
 * Provides information for multiple EC2 Local Gateway Route Tables, such as their identifiers.
 */
export declare function getLocalGatewayRouteTables(args?: GetLocalGatewayRouteTablesArgs, opts?: pulumi.InvokeOptions): Promise<GetLocalGatewayRouteTablesResult>;
/**
 * A collection of arguments for invoking getLocalGatewayRouteTables.
 */
export interface GetLocalGatewayRouteTablesArgs {
    /**
     * Custom filter block as described below.
     */
    readonly filters?: inputs.ec2.GetLocalGatewayRouteTablesFilter[];
    /**
     * A mapping of tags, each pair of which must exactly match
     * a pair on the desired local gateway route table.
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * A collection of values returned by getLocalGatewayRouteTables.
 */
export interface GetLocalGatewayRouteTablesResult {
    readonly filters?: outputs.ec2.GetLocalGatewayRouteTablesFilter[];
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * Set of Local Gateway Route Table identifiers
     */
    readonly ids: string[];
    readonly tags: {
        [key: string]: string;
    };
}
