"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * `aws.ec2.ManagedPrefixList` provides details about a specific AWS prefix list or
 * customer-managed prefix list in the current region.
 *
 * ## Example Usage
 * ### Find the regional DynamoDB prefix list
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const current = pulumi.output(aws.getRegion({ async: true }));
 * const example = current.apply(current => aws.ec2.getManagedPrefixList({
 *     name: `com.amazonaws.${current.name!}.dynamodb`,
 * }, { async: true }));
 * ```
 * ### Find a managed prefix list using filters
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = pulumi.output(aws.ec2.getManagedPrefixList({
 *     filters: [{
 *         name: "prefix-list-name",
 *         values: ["my-prefix-list"],
 *     }],
 * }, { async: true }));
 * ```
 */
function getManagedPrefixList(args, opts) {
    args = args || {};
    if (!opts) {
        opts = {};
    }
    if (!opts.version) {
        opts.version = utilities.getVersion();
    }
    return pulumi.runtime.invoke("aws:ec2/getManagedPrefixList:getManagedPrefixList", {
        "filters": args.filters,
        "id": args.id,
        "name": args.name,
        "tags": args.tags,
    }, opts);
}
exports.getManagedPrefixList = getManagedPrefixList;
//# sourceMappingURL=getManagedPrefixList.js.map