"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * `aws.ec2.getSubnetIds` provides a set of ids for a vpcId
 *
 * This resource can be useful for getting back a set of subnet ids for a vpc.
 *
 * ## Example Usage
 *
 * The following shows outputing all cidr blocks for every subnet id in a vpc.
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const exampleSubnetIds = aws.ec2.getSubnetIds({
 *     vpcId: _var.vpc_id,
 * });
 * const exampleSubnet = exampleSubnetIds.then(exampleSubnetIds => exampleSubnetIds.ids.map((v, k) => [k, v]).map(([, ]) => aws.ec2.getSubnet({
 *     id: __value,
 * })));
 * export const subnetCidrBlocks = exampleSubnet.map(s => s.cidrBlock);
 * ```
 *
 * The following example retrieves a set of all subnets in a VPC with a custom
 * tag of `Tier` set to a value of "Private" so that the `aws.ec2.Instance` resource
 * can loop through the subnets, putting instances across availability zones.
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const private = aws.ec2.getSubnetIds({
 *     vpcId: _var.vpc_id,
 *     tags: {
 *         Tier: "Private",
 *     },
 * });
 * const app: aws.ec2.Instance[];
 * for (const range = {value: 0}; range.value < data.aws_subnet_ids.example.ids; range.value++) {
 *     app.push(new aws.ec2.Instance(`app-${range.value}`, {
 *         ami: _var.ami,
 *         instanceType: "t2.micro",
 *         subnetId: range.value,
 *     }));
 * }
 * ```
 */
function getSubnetIds(args, opts) {
    if (!opts) {
        opts = {};
    }
    if (!opts.version) {
        opts.version = utilities.getVersion();
    }
    return pulumi.runtime.invoke("aws:ec2/getSubnetIds:getSubnetIds", {
        "filters": args.filters,
        "tags": args.tags,
        "vpcId": args.vpcId,
    }, opts);
}
exports.getSubnetIds = getSubnetIds;
//# sourceMappingURL=getSubnetIds.js.map