"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides a VPC DHCP Options Association resource.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const dnsResolver = new aws.ec2.VpcDhcpOptionsAssociation("dnsResolver", {
 *     vpcId: aws_vpc.foo.id,
 *     dhcpOptionsId: aws_vpc_dhcp_options.foo.id,
 * });
 * ```
 * ## Remarks
 *
 * * You can only associate one DHCP Options Set to a given VPC ID.
 * * Removing the DHCP Options Association automatically sets AWS's `default` DHCP Options Set to the VPC.
 *
 * ## Import
 *
 * DHCP associations can be imported by providing the VPC ID associated with the options
 *
 * ```sh
 *  $ pulumi import aws:ec2/vpcDhcpOptionsAssociation:VpcDhcpOptionsAssociation imported vpc-0f001273ec18911b1
 * ```
 */
class VpcDhcpOptionsAssociation extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["dhcpOptionsId"] = state ? state.dhcpOptionsId : undefined;
            inputs["vpcId"] = state ? state.vpcId : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.dhcpOptionsId === undefined) && !opts.urn) {
                throw new Error("Missing required property 'dhcpOptionsId'");
            }
            if ((!args || args.vpcId === undefined) && !opts.urn) {
                throw new Error("Missing required property 'vpcId'");
            }
            inputs["dhcpOptionsId"] = args ? args.dhcpOptionsId : undefined;
            inputs["vpcId"] = args ? args.vpcId : undefined;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(VpcDhcpOptionsAssociation.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing VpcDhcpOptionsAssociation resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new VpcDhcpOptionsAssociation(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of VpcDhcpOptionsAssociation.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === VpcDhcpOptionsAssociation.__pulumiType;
    }
}
exports.VpcDhcpOptionsAssociation = VpcDhcpOptionsAssociation;
/** @internal */
VpcDhcpOptionsAssociation.__pulumiType = 'aws:ec2/vpcDhcpOptionsAssociation:VpcDhcpOptionsAssociation';
//# sourceMappingURL=vpcDhcpOptionsAssociation.js.map