import * as pulumi from "@pulumi/pulumi";
import { input as inputs, output as outputs } from "./types";
/**
 * The Autoscaling Groups data source allows access to the list of AWS
 * ASGs within a specific region. This will allow you to pass a list of AutoScaling Groups to other resources.
 */
/** @deprecated aws.getAutoscalingGroups has been deprecated in favor of aws.autoscaling.getAmiIds */
export declare function getAutoscalingGroups(args?: GetAutoscalingGroupsArgs, opts?: pulumi.InvokeOptions): Promise<GetAutoscalingGroupsResult>;
/**
 * A collection of arguments for invoking getAutoscalingGroups.
 */
export interface GetAutoscalingGroupsArgs {
    /**
     * A filter used to scope the list e.g. by tags. See [related docs](http://docs.aws.amazon.com/AutoScaling/latest/APIReference/API_Filter.html).
     */
    readonly filters?: inputs.GetAutoscalingGroupsFilter[];
}
/**
 * A collection of values returned by getAutoscalingGroups.
 */
export interface GetAutoscalingGroupsResult {
    /**
     * A list of the Autoscaling Groups Arns in the current region.
     */
    readonly arns: string[];
    readonly filters?: outputs.GetAutoscalingGroupsFilter[];
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * A list of the Autoscaling Groups in the current region.
     */
    readonly names: string[];
}
