"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * The Availability Zones data source allows access to the list of AWS
 * Availability Zones which can be accessed by an AWS account within the region
 * configured in the provider.
 *
 * This is different from the `aws.getAvailabilityZone` (singular) data source,
 * which provides some details about a specific availability zone.
 *
 * > When [Local Zones](https://aws.amazon.com/about-aws/global-infrastructure/localzones/) are enabled in a region, by default the API and this data source include both Local Zones and Availability Zones. To return only Availability Zones, see the example section below.
 *
 * ## Example Usage
 * ### By State
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const available = aws.getAvailabilityZones({
 *     state: "available",
 * });
 * const primary = new aws.ec2.Subnet("primary", {availabilityZone: available.then(available => available.names[0])});
 * // ...
 * const secondary = new aws.ec2.Subnet("secondary", {availabilityZone: available.then(available => available.names[1])});
 * // ...
 * ```
 * ### By Filter
 *
 * All Local Zones (regardless of opt-in status):
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = pulumi.output(aws.getAvailabilityZones({
 *     allAvailabilityZones: true,
 *     filters: [{
 *         name: "opt-in-status",
 *         values: [
 *             "not-opted-in",
 *             "opted-in",
 *         ],
 *     }],
 * }, { async: true }));
 * ```
 *
 * Only Availability Zones (no Local Zones):
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = pulumi.output(aws.getAvailabilityZones({
 *     filters: [{
 *         name: "opt-in-status",
 *         values: ["opt-in-not-required"],
 *     }],
 * }, { async: true }));
 * ```
 */
function getAvailabilityZones(args, opts) {
    args = args || {};
    if (!opts) {
        opts = {};
    }
    if (!opts.version) {
        opts.version = utilities.getVersion();
    }
    return pulumi.runtime.invoke("aws:index/getAvailabilityZones:getAvailabilityZones", {
        "allAvailabilityZones": args.allAvailabilityZones,
        "excludeNames": args.excludeNames,
        "excludeZoneIds": args.excludeZoneIds,
        "filters": args.filters,
        "state": args.state,
    }, opts);
}
exports.getAvailabilityZones = getAvailabilityZones;
//# sourceMappingURL=getAvailabilityZones.js.map