"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * `aws.ec2.Eip` provides details about a specific Elastic IP.
 *
 * ## Example Usage
 * ### Search By Allocation ID (VPC only)
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const byAllocationId = pulumi.output(aws.ec2.getElasticIp({
 *     id: "eipalloc-12345678",
 * }, { async: true }));
 * ```
 * ### Search By Filters (EC2-Classic or VPC)
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const byFilter = pulumi.output(aws.ec2.getElasticIp({
 *     filters: [{
 *         name: "tag:Name",
 *         values: ["exampleNameTagValue"],
 *     }],
 * }, { async: true }));
 * ```
 * ### Search By Public IP (EC2-Classic or VPC)
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const byPublicIp = pulumi.output(aws.ec2.getElasticIp({
 *     publicIp: "1.2.3.4",
 * }, { async: true }));
 * ```
 * ### Search By Tags (EC2-Classic or VPC)
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const byTags = pulumi.output(aws.ec2.getElasticIp({
 *     tags: {
 *         Name: "exampleNameTagValue",
 *     },
 * }, { async: true }));
 * ```
 */
/** @deprecated aws.getElasticIp has been deprecated in favor of aws.ec2.getElasticIp */
function getElasticIp(args, opts) {
    pulumi.log.warn("getElasticIp is deprecated: aws.getElasticIp has been deprecated in favor of aws.ec2.getElasticIp");
    args = args || {};
    if (!opts) {
        opts = {};
    }
    if (!opts.version) {
        opts.version = utilities.getVersion();
    }
    return pulumi.runtime.invoke("aws:index/getElasticIp:getElasticIp", {
        "filters": args.filters,
        "id": args.id,
        "publicIp": args.publicIp,
        "tags": args.tags,
    }, opts);
}
exports.getElasticIp = getElasticIp;
//# sourceMappingURL=getElasticIp.js.map