"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides a Glue Development Endpoint resource.
 *
 * ## Example Usage
 *
 * Basic usage:
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const examplePolicyDocument = aws.iam.getPolicyDocument({
 *     statements: [{
 *         actions: ["sts:AssumeRole"],
 *         principals: [{
 *             type: "Service",
 *             identifiers: ["glue.amazonaws.com"],
 *         }],
 *     }],
 * });
 * const exampleRole = new aws.iam.Role("exampleRole", {assumeRolePolicy: examplePolicyDocument.then(examplePolicyDocument => examplePolicyDocument.json)});
 * const exampleDevEndpoint = new aws.glue.DevEndpoint("exampleDevEndpoint", {roleArn: exampleRole.arn});
 * const example_AWSGlueServiceRole = new aws.iam.RolePolicyAttachment("example-AWSGlueServiceRole", {
 *     policyArn: "arn:aws:iam::aws:policy/service-role/AWSGlueServiceRole",
 *     role: exampleRole.name,
 * });
 * ```
 *
 * ## Import
 *
 * A Glue Development Endpoint can be imported using the `name`, e.g.
 *
 * ```sh
 *  $ pulumi import aws:glue/devEndpoint:DevEndpoint example foo
 * ```
 */
class DevEndpoint extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["arguments"] = state ? state.arguments : undefined;
            inputs["arn"] = state ? state.arn : undefined;
            inputs["availabilityZone"] = state ? state.availabilityZone : undefined;
            inputs["extraJarsS3Path"] = state ? state.extraJarsS3Path : undefined;
            inputs["extraPythonLibsS3Path"] = state ? state.extraPythonLibsS3Path : undefined;
            inputs["failureReason"] = state ? state.failureReason : undefined;
            inputs["glueVersion"] = state ? state.glueVersion : undefined;
            inputs["name"] = state ? state.name : undefined;
            inputs["numberOfNodes"] = state ? state.numberOfNodes : undefined;
            inputs["numberOfWorkers"] = state ? state.numberOfWorkers : undefined;
            inputs["privateAddress"] = state ? state.privateAddress : undefined;
            inputs["publicAddress"] = state ? state.publicAddress : undefined;
            inputs["publicKey"] = state ? state.publicKey : undefined;
            inputs["publicKeys"] = state ? state.publicKeys : undefined;
            inputs["roleArn"] = state ? state.roleArn : undefined;
            inputs["securityConfiguration"] = state ? state.securityConfiguration : undefined;
            inputs["securityGroupIds"] = state ? state.securityGroupIds : undefined;
            inputs["status"] = state ? state.status : undefined;
            inputs["subnetId"] = state ? state.subnetId : undefined;
            inputs["tags"] = state ? state.tags : undefined;
            inputs["vpcId"] = state ? state.vpcId : undefined;
            inputs["workerType"] = state ? state.workerType : undefined;
            inputs["yarnEndpointAddress"] = state ? state.yarnEndpointAddress : undefined;
            inputs["zeppelinRemoteSparkInterpreterPort"] = state ? state.zeppelinRemoteSparkInterpreterPort : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.roleArn === undefined) && !opts.urn) {
                throw new Error("Missing required property 'roleArn'");
            }
            inputs["arguments"] = args ? args.arguments : undefined;
            inputs["extraJarsS3Path"] = args ? args.extraJarsS3Path : undefined;
            inputs["extraPythonLibsS3Path"] = args ? args.extraPythonLibsS3Path : undefined;
            inputs["glueVersion"] = args ? args.glueVersion : undefined;
            inputs["name"] = args ? args.name : undefined;
            inputs["numberOfNodes"] = args ? args.numberOfNodes : undefined;
            inputs["numberOfWorkers"] = args ? args.numberOfWorkers : undefined;
            inputs["publicKey"] = args ? args.publicKey : undefined;
            inputs["publicKeys"] = args ? args.publicKeys : undefined;
            inputs["roleArn"] = args ? args.roleArn : undefined;
            inputs["securityConfiguration"] = args ? args.securityConfiguration : undefined;
            inputs["securityGroupIds"] = args ? args.securityGroupIds : undefined;
            inputs["subnetId"] = args ? args.subnetId : undefined;
            inputs["tags"] = args ? args.tags : undefined;
            inputs["workerType"] = args ? args.workerType : undefined;
            inputs["arn"] = undefined /*out*/;
            inputs["availabilityZone"] = undefined /*out*/;
            inputs["failureReason"] = undefined /*out*/;
            inputs["privateAddress"] = undefined /*out*/;
            inputs["publicAddress"] = undefined /*out*/;
            inputs["status"] = undefined /*out*/;
            inputs["vpcId"] = undefined /*out*/;
            inputs["yarnEndpointAddress"] = undefined /*out*/;
            inputs["zeppelinRemoteSparkInterpreterPort"] = undefined /*out*/;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(DevEndpoint.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing DevEndpoint resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new DevEndpoint(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of DevEndpoint.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === DevEndpoint.__pulumiType;
    }
}
exports.DevEndpoint = DevEndpoint;
/** @internal */
DevEndpoint.__pulumiType = 'aws:glue/devEndpoint:DevEndpoint';
//# sourceMappingURL=devEndpoint.js.map