"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides a Glue Schema resource.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = new aws.glue.Schema("example", {
 *     schemaName: "example",
 *     registryArn: aws_glue_registry.test.arn,
 *     dataFormat: "AVRO",
 *     compatibility: "NONE",
 *     schemaDefinition: "{\"type\": \"record\", \"name\": \"r1\", \"fields\": [ {\"name\": \"f1\", \"type\": \"int\"}, {\"name\": \"f2\", \"type\": \"string\"} ]}",
 * });
 * ```
 *
 * ## Import
 *
 * Glue Registries can be imported using `arn`, e.g.
 *
 * ```sh
 *  $ pulumi import aws:glue/schema:Schema example arn:aws:glue:us-west-2:123456789012:schema/example/example
 * ```
 */
class Schema extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["arn"] = state ? state.arn : undefined;
            inputs["compatibility"] = state ? state.compatibility : undefined;
            inputs["dataFormat"] = state ? state.dataFormat : undefined;
            inputs["description"] = state ? state.description : undefined;
            inputs["latestSchemaVersion"] = state ? state.latestSchemaVersion : undefined;
            inputs["nextSchemaVersion"] = state ? state.nextSchemaVersion : undefined;
            inputs["registryArn"] = state ? state.registryArn : undefined;
            inputs["registryName"] = state ? state.registryName : undefined;
            inputs["schemaCheckpoint"] = state ? state.schemaCheckpoint : undefined;
            inputs["schemaDefinition"] = state ? state.schemaDefinition : undefined;
            inputs["schemaName"] = state ? state.schemaName : undefined;
            inputs["tags"] = state ? state.tags : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.compatibility === undefined) && !opts.urn) {
                throw new Error("Missing required property 'compatibility'");
            }
            if ((!args || args.dataFormat === undefined) && !opts.urn) {
                throw new Error("Missing required property 'dataFormat'");
            }
            if ((!args || args.schemaDefinition === undefined) && !opts.urn) {
                throw new Error("Missing required property 'schemaDefinition'");
            }
            if ((!args || args.schemaName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'schemaName'");
            }
            inputs["compatibility"] = args ? args.compatibility : undefined;
            inputs["dataFormat"] = args ? args.dataFormat : undefined;
            inputs["description"] = args ? args.description : undefined;
            inputs["registryArn"] = args ? args.registryArn : undefined;
            inputs["schemaDefinition"] = args ? args.schemaDefinition : undefined;
            inputs["schemaName"] = args ? args.schemaName : undefined;
            inputs["tags"] = args ? args.tags : undefined;
            inputs["arn"] = undefined /*out*/;
            inputs["latestSchemaVersion"] = undefined /*out*/;
            inputs["nextSchemaVersion"] = undefined /*out*/;
            inputs["registryName"] = undefined /*out*/;
            inputs["schemaCheckpoint"] = undefined /*out*/;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(Schema.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing Schema resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new Schema(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of Schema.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Schema.__pulumiType;
    }
}
exports.Schema = Schema;
/** @internal */
Schema.__pulumiType = 'aws:glue/schema:Schema';
//# sourceMappingURL=schema.js.map