"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Manages a Glue Security Configuration.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = new aws.glue.SecurityConfiguration("example", {encryptionConfiguration: {
 *     cloudwatchEncryption: {
 *         cloudwatchEncryptionMode: "DISABLED",
 *     },
 *     jobBookmarksEncryption: {
 *         jobBookmarksEncryptionMode: "DISABLED",
 *     },
 *     s3Encryption: {
 *         kmsKeyArn: data.aws_kms_key.example.arn,
 *         s3EncryptionMode: "SSE-KMS",
 *     },
 * }});
 * ```
 *
 * ## Import
 *
 * Glue Security Configurations can be imported using `name`, e.g.
 *
 * ```sh
 *  $ pulumi import aws:glue/securityConfiguration:SecurityConfiguration example example
 * ```
 */
class SecurityConfiguration extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["encryptionConfiguration"] = state ? state.encryptionConfiguration : undefined;
            inputs["name"] = state ? state.name : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.encryptionConfiguration === undefined) && !opts.urn) {
                throw new Error("Missing required property 'encryptionConfiguration'");
            }
            inputs["encryptionConfiguration"] = args ? args.encryptionConfiguration : undefined;
            inputs["name"] = args ? args.name : undefined;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(SecurityConfiguration.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing SecurityConfiguration resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new SecurityConfiguration(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of SecurityConfiguration.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === SecurityConfiguration.__pulumiType;
    }
}
exports.SecurityConfiguration = SecurityConfiguration;
/** @internal */
SecurityConfiguration.__pulumiType = 'aws:glue/securityConfiguration:SecurityConfiguration';
//# sourceMappingURL=securityConfiguration.js.map