"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Generates an IAM policy document in JSON format for use with resources that expect policy documents such as `aws.iam.Policy`.
 *
 * Using this data source to generate policy documents is *optional*. It is also valid to use literal JSON strings in your configuration or to use the `file` interpolation function to read a raw JSON policy document from a file.
 *
 * ## Example Usage
 * ### Example with Both Source and Override Documents
 *
 * You can also combine `sourceJson` and `overrideJson` in the same document.
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const source = aws.iam.getPolicyDocument({
 *     statements: [{
 *         sid: "OverridePlaceholder",
 *         actions: ["ec2:DescribeAccountAttributes"],
 *         resources: ["*"],
 *     }],
 * });
 * const override = aws.iam.getPolicyDocument({
 *     statements: [{
 *         sid: "OverridePlaceholder",
 *         actions: ["s3:GetObject"],
 *         resources: ["*"],
 *     }],
 * });
 * const politik = Promise.all([source, override]).then(([source, override]) => aws.iam.getPolicyDocument({
 *     sourceJson: source.json,
 *     overrideJson: override.json,
 * }));
 * ```
 *
 * `data.aws_iam_policy_document.politik.json` will evaluate to:
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * ```
 */
function getPolicyDocument(args, opts) {
    args = args || {};
    if (!opts) {
        opts = {};
    }
    if (!opts.version) {
        opts.version = utilities.getVersion();
    }
    return pulumi.runtime.invoke("aws:iam/getPolicyDocument:getPolicyDocument", {
        "overrideJson": args.overrideJson,
        "overridePolicyDocuments": args.overridePolicyDocuments,
        "policyId": args.policyId,
        "sourceJson": args.sourceJson,
        "sourcePolicyDocuments": args.sourcePolicyDocuments,
        "statements": args.statements,
        "version": args.version,
    }, opts);
}
exports.getPolicyDocument = getPolicyDocument;
//# sourceMappingURL=getPolicyDocument.js.map