import { Principal } from "./documents";
export declare module Principals {
    /**
     * Service Principal for Amazon Certificate Manager
     */
    const AcmServicePrincipal: Principal;
    /**
     * Service Principal for API Gateway
     */
    const ApiGatewayPrincipal: Principal;
    /**
     * Service Principal for Athena
     */
    const AthenaPrincipal: Principal;
    /**
     * Service Principal for Autoscaling
     */
    const AutoscalingPrincipal: Principal;
    /**
     * Service Principal for Batch
     */
    const BatchPrincipal: Principal;
    /**
     * Service Principal for Cloud Directory
     */
    const CloudDirectoryPrincipal: Principal;
    /**
     * Service Principal for Cloudformation
     */
    const CloudformationPrincipal: Principal;
    /**
     * Service Principal for Cloudfront
     */
    const CloudfrontPrincipal: Principal;
    /**
     * Service Principal for Cloud Search
     */
    const CloudSearchPrincipal: Principal;
    /**
     * Service Principal for Cloudtrail
     */
    const CloudtrailPrincipal: Principal;
    /**
     * Service Principal for CodeCommit
     */
    const CodeCommitPrincipal: Principal;
    /**
     * Service Principal for CodeBuild
     */
    const CodeBuildPrincipal: Principal;
    /**
     * Service Principal for CodeDeploy
     */
    const CodeDeployPrincipal: Principal;
    /**
     * Service Principal for CodePipeline
     */
    const CodePipelinePrincipal: Principal;
    /**
     * Service Principal for EC2 Config Service
     */
    const ConfigPrincipal: Principal;
    /**
     * Service Principal for Data Pipeline
     */
    const DataPipelinePrincipal: Principal;
    /**
     * Service Principal for DirectConnect
     */
    const DirectConnectPrincipal: Principal;
    /**
     * Service Principal for Directory Services
     */
    const DirectoryServicesPrincipal: Principal;
    /**
     * Service Principal for DynamoDB
     */
    const DynamoDbPrincipal: Principal;
    /**
     * Service Principal for EC2
     */
    const Ec2Principal: Principal;
    /**
     * Service Principal for Elastic Container Registry
     */
    const EcrPrincipal: Principal;
    /**
     * Service Principal for Elastic Container Service
     */
    const EcsPrincipal: Principal;
    /**
     * Service Principal for Elastic Container Service Tasks
     * Usage: https://docs.aws.amazon.com/AmazonECS/latest/developerguide/task-iam-roles.html
    */
    const EcsTasksPrincipal: Principal;
    /**
     * Service Principal for Edge Lambda
     */
    const EdgeLambdaPrincipal: Principal;
    /**
     * Service Principal for Elasticache
     */
    const ElasticachePrincipal: Principal;
    /**
     * Service Principal for Elastic Beanstalk
     */
    const ElasticBeanstalkPrincipal: Principal;
    /**
     * Service Principal for Elastic File System
     */
    const ElasticFileSystemPrincipal: Principal;
    /**
     * Service Principal for Elastic Load Balancing
     */
    const ElasticLoadBalancingPrincipal: Principal;
    /**
     * Service Principal for Elastic MapReduce
     */
    const ElasticMapReducePrincipal: Principal;
    /**
     * Service Principal for Events
     */
    const EventsPrincipal: Principal;
    /**
     * Service Principal for Health
     */
    const HealthPrincipal: Principal;
    /**
     * Service Principal for IAM
     */
    const IamPrincipal: Principal;
    /**
     * Service Principal for AWS Inspector
     */
    const InspectorPrincipal: Principal;
    /**
     * Service Principal for Kinesis
     */
    const KinesisPrincipal: Principal;
    /**
     * Service Principal for Key Mangaement Service
     */
    const KmsPrincipal: Principal;
    /**
     * Service Principal for Lambda
     */
    const LambdaPrincipal: Principal;
    /**
     * Service Principal for Lightsail
     */
    const LightsailPrincipal: Principal;
    /**
     * Service Principal for Cloudwatch Logs
     */
    const LogsPrincipal: Principal;
    /**
     * Service Principal for Cloudwatch Monitoring
     */
    const MonitoringPrincipal: Principal;
    /**
     * Service Principal for Opsworks
     */
    const OpsworksPrincipal: Principal;
    /**
     * Service Principal for Organizations
     */
    const OrganizationsPrincipal: Principal;
    /**
     * Service Principal for Relational Database Service
     */
    const RdsPrincipal: Principal;
    /**
     * Service Principal for Redshift
     */
    const RedshiftPrincipal: Principal;
    /**
     * Service Principal for Route 53
     */
    const Route53Principal: Principal;
    /**
     * Service Principal for S3
     */
    const S3Principal: Principal;
    /**
     * Service Principal for Service Catalog
     */
    const ServiceCatalogPrincipal: Principal;
    /**
     * Service Principal for Simple Email Service
     */
    const SesPrincipal: Principal;
    /**
     * Service Principal for Signin Service
     */
    const SigninPrincipal: Principal;
    /**
     * Service Principal for Simple Notification Service
     */
    const SnsPrincipal: Principal;
    /**
     * Service Principal for Simple Queue Service
     */
    const SqsPrincipal: Principal;
    /**
     * Service Principal for Spot Fleet
     */
    const SpotFleetPrincipal: Principal;
    /**
     * Service Principal for Systems Manager
     */
    const SsmPrincipal: Principal;
    /**
     * Service Principal for Storage Gateway
     */
    const StorageGatewayPrincipal: Principal;
    /**
     * Service Principal for Security Token Service
     */
    const StsPrincipal: Principal;
    /**
     * Service Principal for AWS Support
     */
    const SupportPrincipal: Principal;
    /**
     * Service Principal for VM Import/Export
     */
    const VmiePrincipal: Principal;
    /**
     * Service Principal for VPC Flow Logs
     */
    const VpcFlowLogsPrincipal: Principal;
    /**
     * Service Principal for Web Application Firewall
     */
    const WafPrincipal: Principal;
    /**
     * Service Principal for WorkDocs
     */
    const WorkDocsPrincipal: Principal;
    /**
     * Service Principal for Workspaces
     */
    const WorkspacesPrincipal: Principal;
}
