"use strict";
// Copyright 2016-2018, Pulumi Corporation.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
Object.defineProperty(exports, "__esModule", { value: true });
var Principals;
(function (Principals) {
    /**
     * Service Principal for Amazon Certificate Manager
     */
    Principals.AcmServicePrincipal = { Service: "acm.amazonaws.com" };
    /**
     * Service Principal for API Gateway
     */
    Principals.ApiGatewayPrincipal = { Service: "apigateway.amazonaws.com" };
    /**
     * Service Principal for Athena
     */
    Principals.AthenaPrincipal = { Service: "athena.amazonaws.com" };
    /**
     * Service Principal for Autoscaling
     */
    Principals.AutoscalingPrincipal = { Service: "autoscaling.amazonaws.com" };
    /**
     * Service Principal for Batch
     */
    Principals.BatchPrincipal = { Service: "batch.amazonaws.com" };
    /**
     * Service Principal for Cloud Directory
     */
    Principals.CloudDirectoryPrincipal = { Service: "clouddirectory.amazonaws.com" };
    /**
     * Service Principal for Cloudformation
     */
    Principals.CloudformationPrincipal = { Service: "cloudformation.amazonaws.com" };
    /**
     * Service Principal for Cloudfront
     */
    Principals.CloudfrontPrincipal = { Service: "cloudfront.amazonaws.com" };
    /**
     * Service Principal for Cloud Search
     */
    Principals.CloudSearchPrincipal = { Service: "cloudsearch.amazonaws.com" };
    /**
     * Service Principal for Cloudtrail
     */
    Principals.CloudtrailPrincipal = { Service: "cloudtrail.amazonaws.com" };
    /**
     * Service Principal for CodeCommit
     */
    Principals.CodeCommitPrincipal = { Service: "codecommit.amazonaws.com" };
    /**
     * Service Principal for CodeBuild
     */
    Principals.CodeBuildPrincipal = { Service: "codebuild.amazonaws.com" };
    /**
     * Service Principal for CodeDeploy
     */
    Principals.CodeDeployPrincipal = { Service: "codedeploy.amazonaws.com" };
    /**
     * Service Principal for CodePipeline
     */
    Principals.CodePipelinePrincipal = { Service: "codepipeline.amazonaws.com" };
    /**
     * Service Principal for EC2 Config Service
     */
    Principals.ConfigPrincipal = { Service: "config.amazonaws.com" };
    /**
     * Service Principal for Data Pipeline
     */
    Principals.DataPipelinePrincipal = { Service: "datapipeline.amazonaws.com" };
    /**
     * Service Principal for DirectConnect
     */
    Principals.DirectConnectPrincipal = { Service: "directconnect.amazonaws.com" };
    /**
     * Service Principal for Directory Services
     */
    Principals.DirectoryServicesPrincipal = { Service: "ds.amazonaws.com" };
    /**
     * Service Principal for DynamoDB
     */
    Principals.DynamoDbPrincipal = { Service: "dynamodb.amazonaws.com" };
    /**
     * Service Principal for EC2
     */
    Principals.Ec2Principal = { Service: "ec2.amazonaws.com" };
    /**
     * Service Principal for Elastic Container Registry
     */
    Principals.EcrPrincipal = { Service: "ecr.amazonaws.com" };
    /**
     * Service Principal for Elastic Container Service
     */
    Principals.EcsPrincipal = { Service: "ecs.amazonaws.com" };
    /**
     * Service Principal for Elastic Container Service Tasks
     * Usage: https://docs.aws.amazon.com/AmazonECS/latest/developerguide/task-iam-roles.html
    */
    Principals.EcsTasksPrincipal = { Service: "ecs-tasks.amazonaws.com" };
    /**
     * Service Principal for Edge Lambda
     */
    Principals.EdgeLambdaPrincipal = { Service: "edgelambda.amazonaws.com" };
    /**
     * Service Principal for Elasticache
     */
    Principals.ElasticachePrincipal = { Service: "elasticache.amazonaws.com" };
    /**
     * Service Principal for Elastic Beanstalk
     */
    Principals.ElasticBeanstalkPrincipal = { Service: "elasticbeanstalk.amazonaws.com" };
    /**
     * Service Principal for Elastic File System
     */
    Principals.ElasticFileSystemPrincipal = { Service: "elasticfilesystem.amazonaws.com" };
    /**
     * Service Principal for Elastic Load Balancing
     */
    Principals.ElasticLoadBalancingPrincipal = { Service: "elasticloadbalancing.amazonaws.com" };
    /**
     * Service Principal for Elastic MapReduce
     */
    Principals.ElasticMapReducePrincipal = { Service: "elasticmapreduce.amazonaws.com" };
    /**
     * Service Principal for Events
     */
    Principals.EventsPrincipal = { Service: "events.amazonaws.com" };
    /**
     * Service Principal for Health
     */
    Principals.HealthPrincipal = { Service: "health.amazonaws.com" };
    /**
     * Service Principal for IAM
     */
    Principals.IamPrincipal = { Service: "iam.amazonaws.com" };
    /**
     * Service Principal for AWS Inspector
     */
    Principals.InspectorPrincipal = { Service: "inspector.amazonaws.com" };
    /**
     * Service Principal for Kinesis
     */
    Principals.KinesisPrincipal = { Service: "kinesis.amazonaws.com" };
    /**
     * Service Principal for Key Mangaement Service
     */
    Principals.KmsPrincipal = { Service: "kms.amazonaws.com" };
    /**
     * Service Principal for Lambda
     */
    Principals.LambdaPrincipal = { Service: "lambda.amazonaws.com" };
    /**
     * Service Principal for Lightsail
     */
    Principals.LightsailPrincipal = { Service: "lightsail.amazonaws.com" };
    /**
     * Service Principal for Cloudwatch Logs
     */
    Principals.LogsPrincipal = { Service: "logs.amazonaws.com" };
    /**
     * Service Principal for Cloudwatch Monitoring
     */
    Principals.MonitoringPrincipal = { Service: "monitoring.amazonaws.com" };
    /**
     * Service Principal for Opsworks
     */
    Principals.OpsworksPrincipal = { Service: "opsworks.amazonaws.com" };
    /**
     * Service Principal for Organizations
     */
    Principals.OrganizationsPrincipal = { Service: "organizations.amazonaws.com" };
    /**
     * Service Principal for Relational Database Service
     */
    Principals.RdsPrincipal = { Service: "rds.amazonaws.com" };
    /**
     * Service Principal for Redshift
     */
    Principals.RedshiftPrincipal = { Service: "redshift.amazonaws.com" };
    /**
     * Service Principal for Route 53
     */
    Principals.Route53Principal = { Service: "route53.amazonaws.com" };
    /**
     * Service Principal for S3
     */
    Principals.S3Principal = { Service: "s3.amazonaws.com" };
    /**
     * Service Principal for Service Catalog
     */
    Principals.ServiceCatalogPrincipal = { Service: "servicecatalog.amazonaws.com" };
    /**
     * Service Principal for Simple Email Service
     */
    Principals.SesPrincipal = { Service: "ses.amazonaws.com" };
    /**
     * Service Principal for Signin Service
     */
    Principals.SigninPrincipal = { Service: "signin.amazonaws.com" };
    /**
     * Service Principal for Simple Notification Service
     */
    Principals.SnsPrincipal = { Service: "sns.amazonaws.com" };
    /**
     * Service Principal for Simple Queue Service
     */
    Principals.SqsPrincipal = { Service: "sqs.amazonaws.com" };
    /**
     * Service Principal for Spot Fleet
     */
    Principals.SpotFleetPrincipal = { Service: "spotfleet.amazonaws.com" };
    /**
     * Service Principal for Systems Manager
     */
    Principals.SsmPrincipal = { Service: "ssm.amazonaws.com" };
    /**
     * Service Principal for Storage Gateway
     */
    Principals.StorageGatewayPrincipal = { Service: "storagegateway.amazonaws.com" };
    /**
     * Service Principal for Security Token Service
     */
    Principals.StsPrincipal = { Service: "sts.amazonaws.com" };
    /**
     * Service Principal for AWS Support
     */
    Principals.SupportPrincipal = { Service: "support.amazonaws.com" };
    /**
     * Service Principal for VM Import/Export
     */
    Principals.VmiePrincipal = { Service: "vmie.amazonaws.com" };
    /**
     * Service Principal for VPC Flow Logs
     */
    Principals.VpcFlowLogsPrincipal = { Service: "vpc-flow-logs.amazonaws.com" };
    /**
     * Service Principal for Web Application Firewall
     */
    Principals.WafPrincipal = { Service: "waf.amazonaws.com" };
    /**
     * Service Principal for WorkDocs
     */
    Principals.WorkDocsPrincipal = { Service: "workdocs.amazonaws.com" };
    /**
     * Service Principal for Workspaces
     */
    Principals.WorkspacesPrincipal = { Service: "workspaces.amazonaws.com" };
})(Principals = exports.Principals || (exports.Principals = {}));
//# sourceMappingURL=principals.js.map