"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Manages an Image Builder Image.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = new aws.imagebuilder.Image("example", {
 *     distributionConfigurationArn: aws_imagebuilder_distribution_configuration.example.arn,
 *     imageRecipeArn: aws_imagebuilder_image_recipe.example.arn,
 *     infrastructureConfigurationArn: aws_imagebuilder_infrastructure_configuration.example.arn,
 * });
 * ```
 *
 * ## Import
 *
 * `aws_imagebuilder_image` resources can be imported using the Amazon Resource Name (ARN), e.g.
 *
 * ```sh
 *  $ pulumi import aws:imagebuilder/image:Image example arn:aws:imagebuilder:us-east-1:123456789012:image/example/1.0.0/1
 * ```
 */
class Image extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["arn"] = state ? state.arn : undefined;
            inputs["dateCreated"] = state ? state.dateCreated : undefined;
            inputs["distributionConfigurationArn"] = state ? state.distributionConfigurationArn : undefined;
            inputs["enhancedImageMetadataEnabled"] = state ? state.enhancedImageMetadataEnabled : undefined;
            inputs["imageRecipeArn"] = state ? state.imageRecipeArn : undefined;
            inputs["imageTestsConfiguration"] = state ? state.imageTestsConfiguration : undefined;
            inputs["infrastructureConfigurationArn"] = state ? state.infrastructureConfigurationArn : undefined;
            inputs["name"] = state ? state.name : undefined;
            inputs["osVersion"] = state ? state.osVersion : undefined;
            inputs["outputResources"] = state ? state.outputResources : undefined;
            inputs["platform"] = state ? state.platform : undefined;
            inputs["tags"] = state ? state.tags : undefined;
            inputs["version"] = state ? state.version : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.imageRecipeArn === undefined) && !opts.urn) {
                throw new Error("Missing required property 'imageRecipeArn'");
            }
            if ((!args || args.infrastructureConfigurationArn === undefined) && !opts.urn) {
                throw new Error("Missing required property 'infrastructureConfigurationArn'");
            }
            inputs["distributionConfigurationArn"] = args ? args.distributionConfigurationArn : undefined;
            inputs["enhancedImageMetadataEnabled"] = args ? args.enhancedImageMetadataEnabled : undefined;
            inputs["imageRecipeArn"] = args ? args.imageRecipeArn : undefined;
            inputs["imageTestsConfiguration"] = args ? args.imageTestsConfiguration : undefined;
            inputs["infrastructureConfigurationArn"] = args ? args.infrastructureConfigurationArn : undefined;
            inputs["tags"] = args ? args.tags : undefined;
            inputs["arn"] = undefined /*out*/;
            inputs["dateCreated"] = undefined /*out*/;
            inputs["name"] = undefined /*out*/;
            inputs["osVersion"] = undefined /*out*/;
            inputs["outputResources"] = undefined /*out*/;
            inputs["platform"] = undefined /*out*/;
            inputs["version"] = undefined /*out*/;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(Image.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing Image resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new Image(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of Image.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Image.__pulumiType;
    }
}
exports.Image = Image;
/** @internal */
Image.__pulumiType = 'aws:imagebuilder/image:Image';
//# sourceMappingURL=image.js.map