"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * The AWS Inspector Rules Packages data source allows access to the list of AWS
 * Inspector Rules Packages which can be used by AWS Inspector within the region
 * configured in the provider.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const rules = aws.inspector.getRulesPackages({});
 * // e.g. Use in aws_inspector_assessment_template
 * const group = new aws.inspector.ResourceGroup("group", {tags: {
 *     test: "test",
 * }});
 * const assessmentAssessmentTarget = new aws.inspector.AssessmentTarget("assessmentAssessmentTarget", {resourceGroupArn: group.arn});
 * const assessmentAssessmentTemplate = new aws.inspector.AssessmentTemplate("assessmentAssessmentTemplate", {
 *     targetArn: assessmentAssessmentTarget.arn,
 *     duration: "60",
 *     rulesPackageArns: rules.then(rules => rules.arns),
 * });
 * ```
 */
function getRulesPackages(opts) {
    if (!opts) {
        opts = {};
    }
    if (!opts.version) {
        opts.version = utilities.getVersion();
    }
    return pulumi.runtime.invoke("aws:inspector/getRulesPackages:getRulesPackages", {}, opts);
}
exports.getRulesPackages = getRulesPackages;
//# sourceMappingURL=getRulesPackages.js.map