"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Creates and manages an AWS IoT Thing.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = new aws.iot.Thing("example", {
 *     attributes: {
 *         First: "examplevalue",
 *     },
 * });
 * ```
 *
 * ## Import
 *
 * IOT Things can be imported using the name, e.g.
 *
 * ```sh
 *  $ pulumi import aws:iot/thing:Thing example example
 * ```
 */
class Thing extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["arn"] = state ? state.arn : undefined;
            inputs["attributes"] = state ? state.attributes : undefined;
            inputs["defaultClientId"] = state ? state.defaultClientId : undefined;
            inputs["name"] = state ? state.name : undefined;
            inputs["thingTypeName"] = state ? state.thingTypeName : undefined;
            inputs["version"] = state ? state.version : undefined;
        }
        else {
            const args = argsOrState;
            inputs["attributes"] = args ? args.attributes : undefined;
            inputs["name"] = args ? args.name : undefined;
            inputs["thingTypeName"] = args ? args.thingTypeName : undefined;
            inputs["arn"] = undefined /*out*/;
            inputs["defaultClientId"] = undefined /*out*/;
            inputs["version"] = undefined /*out*/;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(Thing.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing Thing resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new Thing(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of Thing.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Thing.__pulumiType;
    }
}
exports.Thing = Thing;
/** @internal */
Thing.__pulumiType = 'aws:iot/thing:Thing';
//# sourceMappingURL=thing.js.map