"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Attaches Principal to AWS IoT Thing.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 * import * from "fs";
 *
 * const example = new aws.iot.Thing("example", {});
 * const cert = new aws.iot.Certificate("cert", {
 *     csr: fs.readFileSync("csr.pem"),
 *     active: true,
 * });
 * const att = new aws.iot.ThingPrincipalAttachment("att", {
 *     principal: cert.arn,
 *     thing: example.name,
 * });
 * ```
 */
class ThingPrincipalAttachment extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["principal"] = state ? state.principal : undefined;
            inputs["thing"] = state ? state.thing : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.principal === undefined) && !opts.urn) {
                throw new Error("Missing required property 'principal'");
            }
            if ((!args || args.thing === undefined) && !opts.urn) {
                throw new Error("Missing required property 'thing'");
            }
            inputs["principal"] = args ? args.principal : undefined;
            inputs["thing"] = args ? args.thing : undefined;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(ThingPrincipalAttachment.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing ThingPrincipalAttachment resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new ThingPrincipalAttachment(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of ThingPrincipalAttachment.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === ThingPrincipalAttachment.__pulumiType;
    }
}
exports.ThingPrincipalAttachment = ThingPrincipalAttachment;
/** @internal */
ThingPrincipalAttachment.__pulumiType = 'aws:iot/thingPrincipalAttachment:ThingPrincipalAttachment';
//# sourceMappingURL=thingPrincipalAttachment.js.map