"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Manages a Lambda Provisioned Concurrency Configuration.
 *
 * ## Example Usage
 * ### Alias Name
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = new aws.lambda.ProvisionedConcurrencyConfig("example", {
 *     functionName: aws_lambda_alias.example.function_name,
 *     provisionedConcurrentExecutions: 1,
 *     qualifier: aws_lambda_alias.example.name,
 * });
 * ```
 * ### Function Version
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = new aws.lambda.ProvisionedConcurrencyConfig("example", {
 *     functionName: aws_lambda_function.example.function_name,
 *     provisionedConcurrentExecutions: 1,
 *     qualifier: aws_lambda_function.example.version,
 * });
 * ```
 *
 * ## Import
 *
 * Lambda Provisioned Concurrency Configs can be imported using the `function_name` and `qualifier` separated by a colon (`:`), e.g.
 *
 * ```sh
 *  $ pulumi import aws:lambda/provisionedConcurrencyConfig:ProvisionedConcurrencyConfig example my_function:production
 * ```
 */
class ProvisionedConcurrencyConfig extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["functionName"] = state ? state.functionName : undefined;
            inputs["provisionedConcurrentExecutions"] = state ? state.provisionedConcurrentExecutions : undefined;
            inputs["qualifier"] = state ? state.qualifier : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.functionName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'functionName'");
            }
            if ((!args || args.provisionedConcurrentExecutions === undefined) && !opts.urn) {
                throw new Error("Missing required property 'provisionedConcurrentExecutions'");
            }
            if ((!args || args.qualifier === undefined) && !opts.urn) {
                throw new Error("Missing required property 'qualifier'");
            }
            inputs["functionName"] = args ? args.functionName : undefined;
            inputs["provisionedConcurrentExecutions"] = args ? args.provisionedConcurrentExecutions : undefined;
            inputs["qualifier"] = args ? args.qualifier : undefined;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(ProvisionedConcurrencyConfig.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing ProvisionedConcurrencyConfig resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new ProvisionedConcurrencyConfig(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of ProvisionedConcurrencyConfig.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === ProvisionedConcurrencyConfig.__pulumiType;
    }
}
exports.ProvisionedConcurrencyConfig = ProvisionedConcurrencyConfig;
/** @internal */
ProvisionedConcurrencyConfig.__pulumiType = 'aws:lambda/provisionedConcurrencyConfig:ProvisionedConcurrencyConfig';
//# sourceMappingURL=provisionedConcurrencyConfig.js.map