"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides an Amazon Lex Bot resource. For more information see
 * [Amazon Lex: How It Works](https://docs.aws.amazon.com/lex/latest/dg/how-it-works.html)
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const orderFlowersBot = new aws.lex.Bot("order_flowers_bot", {
 *     abortStatement: {
 *         messages: [{
 *             content: "Sorry, I am not able to assist at this time",
 *             contentType: "PlainText",
 *         }],
 *     },
 *     childDirected: false,
 *     clarificationPrompt: {
 *         maxAttempts: 2,
 *         messages: [{
 *             content: "I didn't understand you, what would you like to do?",
 *             contentType: "PlainText",
 *         }],
 *     },
 *     createVersion: false,
 *     description: "Bot to order flowers on the behalf of a user",
 *     idleSessionTtlInSeconds: 600,
 *     intents: [{
 *         intentName: "OrderFlowers",
 *         intentVersion: "1",
 *     }],
 *     locale: "en-US",
 *     name: "OrderFlowers",
 *     processBehavior: "BUILD",
 *     voiceId: "Salli",
 * });
 * ```
 *
 * ## Import
 *
 * Bots can be imported using their name.
 *
 * ```sh
 *  $ pulumi import aws:lex/bot:Bot order_flowers_bot OrderFlowers
 * ```
 */
class Bot extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["abortStatement"] = state ? state.abortStatement : undefined;
            inputs["arn"] = state ? state.arn : undefined;
            inputs["checksum"] = state ? state.checksum : undefined;
            inputs["childDirected"] = state ? state.childDirected : undefined;
            inputs["clarificationPrompt"] = state ? state.clarificationPrompt : undefined;
            inputs["createVersion"] = state ? state.createVersion : undefined;
            inputs["createdDate"] = state ? state.createdDate : undefined;
            inputs["description"] = state ? state.description : undefined;
            inputs["detectSentiment"] = state ? state.detectSentiment : undefined;
            inputs["enableModelImprovements"] = state ? state.enableModelImprovements : undefined;
            inputs["failureReason"] = state ? state.failureReason : undefined;
            inputs["idleSessionTtlInSeconds"] = state ? state.idleSessionTtlInSeconds : undefined;
            inputs["intents"] = state ? state.intents : undefined;
            inputs["lastUpdatedDate"] = state ? state.lastUpdatedDate : undefined;
            inputs["locale"] = state ? state.locale : undefined;
            inputs["name"] = state ? state.name : undefined;
            inputs["nluIntentConfidenceThreshold"] = state ? state.nluIntentConfidenceThreshold : undefined;
            inputs["processBehavior"] = state ? state.processBehavior : undefined;
            inputs["status"] = state ? state.status : undefined;
            inputs["version"] = state ? state.version : undefined;
            inputs["voiceId"] = state ? state.voiceId : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.abortStatement === undefined) && !opts.urn) {
                throw new Error("Missing required property 'abortStatement'");
            }
            if ((!args || args.childDirected === undefined) && !opts.urn) {
                throw new Error("Missing required property 'childDirected'");
            }
            if ((!args || args.intents === undefined) && !opts.urn) {
                throw new Error("Missing required property 'intents'");
            }
            inputs["abortStatement"] = args ? args.abortStatement : undefined;
            inputs["childDirected"] = args ? args.childDirected : undefined;
            inputs["clarificationPrompt"] = args ? args.clarificationPrompt : undefined;
            inputs["createVersion"] = args ? args.createVersion : undefined;
            inputs["description"] = args ? args.description : undefined;
            inputs["detectSentiment"] = args ? args.detectSentiment : undefined;
            inputs["enableModelImprovements"] = args ? args.enableModelImprovements : undefined;
            inputs["idleSessionTtlInSeconds"] = args ? args.idleSessionTtlInSeconds : undefined;
            inputs["intents"] = args ? args.intents : undefined;
            inputs["locale"] = args ? args.locale : undefined;
            inputs["name"] = args ? args.name : undefined;
            inputs["nluIntentConfidenceThreshold"] = args ? args.nluIntentConfidenceThreshold : undefined;
            inputs["processBehavior"] = args ? args.processBehavior : undefined;
            inputs["voiceId"] = args ? args.voiceId : undefined;
            inputs["arn"] = undefined /*out*/;
            inputs["checksum"] = undefined /*out*/;
            inputs["createdDate"] = undefined /*out*/;
            inputs["failureReason"] = undefined /*out*/;
            inputs["lastUpdatedDate"] = undefined /*out*/;
            inputs["status"] = undefined /*out*/;
            inputs["version"] = undefined /*out*/;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(Bot.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing Bot resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new Bot(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of Bot.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Bot.__pulumiType;
    }
}
exports.Bot = Bot;
/** @internal */
Bot.__pulumiType = 'aws:lex/bot:Bot';
//# sourceMappingURL=bot.js.map