"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides an AWS Network Firewall Resource Policy Resource for a rule group or firewall policy.
 *
 * ## Example Usage
 * ### For a Firewall Policy resource
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = new aws.networkfirewall.ResourcePolicy("example", {
 *     resourceArn: aws_networkfirewall_firewall_policy.example.arn,
 *     policy: JSON.stringify({
 *         Statement: [{
 *             Action: [
 *                 "network-firewall:ListFirewallPolicies",
 *                 "network-firewall:CreateFirewall",
 *                 "network-firewall:UpdateFirewall",
 *                 "network-firewall:AssociateFirewallPolicy",
 *             ],
 *             Effect: "Allow",
 *             Resource: aws_networkfirewall_firewall_policy.example.arn,
 *             Principal: {
 *                 AWS: "arn:aws:iam::123456789012:root",
 *             },
 *         }],
 *         Version: "2012-10-17",
 *     }),
 * });
 * ```
 * ### For a Rule Group resource
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = new aws.networkfirewall.ResourcePolicy("example", {
 *     resourceArn: aws_networkfirewall_rule_group.example.arn,
 *     policy: JSON.stringify({
 *         Statement: [{
 *             Action: [
 *                 "network-firewall:ListRuleGroups",
 *                 "network-firewall:CreateFirewallPolicy",
 *                 "network-firewall:UpdateFirewallPolicy",
 *             ],
 *             Effect: "Allow",
 *             Resource: aws_networkfirewall_rule_group.example.arn,
 *             Principal: {
 *                 AWS: "arn:aws:iam::123456789012:root",
 *             },
 *         }],
 *         Version: "2012-10-17",
 *     }),
 * });
 * ```
 *
 * ## Import
 *
 * Network Firewall Resource Policies can be imported using the `resource_arn` e.g.
 *
 * ```sh
 *  $ pulumi import aws:networkfirewall/resourcePolicy:ResourcePolicy example aws_networkfirewall_rule_group.example arn:aws:network-firewall:us-west-1:123456789012:stateful-rulegroup/example
 * ```
 */
class ResourcePolicy extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["policy"] = state ? state.policy : undefined;
            inputs["resourceArn"] = state ? state.resourceArn : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.policy === undefined) && !opts.urn) {
                throw new Error("Missing required property 'policy'");
            }
            if ((!args || args.resourceArn === undefined) && !opts.urn) {
                throw new Error("Missing required property 'resourceArn'");
            }
            inputs["policy"] = args ? args.policy : undefined;
            inputs["resourceArn"] = args ? args.resourceArn : undefined;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(ResourcePolicy.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing ResourcePolicy resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new ResourcePolicy(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of ResourcePolicy.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === ResourcePolicy.__pulumiType;
    }
}
exports.ResourcePolicy = ResourcePolicy;
/** @internal */
ResourcePolicy.__pulumiType = 'aws:networkfirewall/resourcePolicy:ResourcePolicy';
//# sourceMappingURL=resourcePolicy.js.map