import * as pulumi from "@pulumi/pulumi";
/**
 * Information about Outposts Instance Types.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = aws.outposts.getOutpostInstanceTypes({
 *     arn: data.aws_outposts_outpost.example.arn,
 * });
 * ```
 */
export declare function getOutpostInstanceTypes(args: GetOutpostInstanceTypesArgs, opts?: pulumi.InvokeOptions): Promise<GetOutpostInstanceTypesResult>;
/**
 * A collection of arguments for invoking getOutpostInstanceTypes.
 */
export interface GetOutpostInstanceTypesArgs {
    /**
     * Outpost Amazon Resource Name (ARN).
     */
    readonly arn: string;
}
/**
 * A collection of values returned by getOutpostInstanceTypes.
 */
export interface GetOutpostInstanceTypesResult {
    readonly arn: string;
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * Set of instance types.
     */
    readonly instanceTypes: string[];
}
