import * as pulumi from "@pulumi/pulumi";
/**
 * Provides details about an Outposts Site.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = pulumi.output(aws.outposts.getSite({
 *     name: "example",
 * }, { async: true }));
 * ```
 */
export declare function getSite(args?: GetSiteArgs, opts?: pulumi.InvokeOptions): Promise<GetSiteResult>;
/**
 * A collection of arguments for invoking getSite.
 */
export interface GetSiteArgs {
    /**
     * Identifier of the Site.
     */
    readonly id?: string;
    /**
     * Name of the Site.
     */
    readonly name?: string;
}
/**
 * A collection of values returned by getSite.
 */
export interface GetSiteResult {
    /**
     * AWS Account identifier.
     */
    readonly accountId: string;
    /**
     * Description.
     */
    readonly description: string;
    readonly id: string;
    readonly name: string;
}
