import * as pulumi from "@pulumi/pulumi";
/**
 * Provides details about multiple Outposts Sites.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const all = pulumi.output(aws.outposts.getSites({ async: true }));
 * ```
 */
export declare function getSites(opts?: pulumi.InvokeOptions): Promise<GetSitesResult>;
/**
 * A collection of values returned by getSites.
 */
export interface GetSitesResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * Set of Outposts Site identifiers.
     */
    readonly ids: string[];
}
