"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Manages a Resource Access Manager (RAM) Resource Association.
 *
 * > *NOTE:* Certain AWS resources (e.g. EC2 Subnets) can only be shared in an AWS account that is a member of an AWS Organizations organization with organization-wide Resource Access Manager functionality enabled. See the [Resource Access Manager User Guide](https://docs.aws.amazon.com/ram/latest/userguide/what-is.html) and AWS service specific documentation for additional information.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = new aws.ram.ResourceAssociation("example", {
 *     resourceArn: aws_subnet.example.arn,
 *     resourceShareArn: aws_ram_resource_share.example.arn,
 * });
 * ```
 *
 * ## Import
 *
 * RAM Resource Associations can be imported using their Resource Share ARN and Resource ARN separated by a comma, e.g.
 *
 * ```sh
 *  $ pulumi import aws:ram/resourceAssociation:ResourceAssociation example arn:aws:ram:eu-west-1:123456789012:resource-share/73da1ab9-b94a-4ba3-8eb4-45917f7f4b12,arn:aws:ec2:eu-west-1:123456789012:subnet/subnet-12345678
 * ```
 */
class ResourceAssociation extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["resourceArn"] = state ? state.resourceArn : undefined;
            inputs["resourceShareArn"] = state ? state.resourceShareArn : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.resourceArn === undefined) && !opts.urn) {
                throw new Error("Missing required property 'resourceArn'");
            }
            if ((!args || args.resourceShareArn === undefined) && !opts.urn) {
                throw new Error("Missing required property 'resourceShareArn'");
            }
            inputs["resourceArn"] = args ? args.resourceArn : undefined;
            inputs["resourceShareArn"] = args ? args.resourceShareArn : undefined;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(ResourceAssociation.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing ResourceAssociation resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new ResourceAssociation(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of ResourceAssociation.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === ResourceAssociation.__pulumiType;
    }
}
exports.ResourceAssociation = ResourceAssociation;
/** @internal */
ResourceAssociation.__pulumiType = 'aws:ram/resourceAssociation:ResourceAssociation';
//# sourceMappingURL=resourceAssociation.js.map