"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Use this data source to get information about a DB Cluster Snapshot for use when provisioning DB clusters.
 *
 * > **NOTE:** This data source does not apply to snapshots created on DB Instances.
 * See the `aws.rds.Snapshot` data source for DB Instance snapshots.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const developmentFinalSnapshot = aws.rds.getClusterSnapshot({
 *     dbClusterIdentifier: "development_cluster",
 *     mostRecent: true,
 * });
 * // Use the last snapshot of the dev database before it was destroyed to create
 * // a new dev database.
 * const auroraCluster = new aws.rds.Cluster("auroraCluster", {
 *     clusterIdentifier: "development_cluster",
 *     snapshotIdentifier: developmentFinalSnapshot.then(developmentFinalSnapshot => developmentFinalSnapshot.id),
 *     dbSubnetGroupName: "my_db_subnet_group",
 * });
 * const auroraClusterInstance = new aws.rds.ClusterInstance("auroraClusterInstance", {
 *     clusterIdentifier: auroraCluster.id,
 *     instanceClass: "db.t2.small",
 *     dbSubnetGroupName: "my_db_subnet_group",
 * });
 * ```
 */
function getClusterSnapshot(args, opts) {
    args = args || {};
    if (!opts) {
        opts = {};
    }
    if (!opts.version) {
        opts.version = utilities.getVersion();
    }
    return pulumi.runtime.invoke("aws:rds/getClusterSnapshot:getClusterSnapshot", {
        "dbClusterIdentifier": args.dbClusterIdentifier,
        "dbClusterSnapshotIdentifier": args.dbClusterSnapshotIdentifier,
        "includePublic": args.includePublic,
        "includeShared": args.includeShared,
        "mostRecent": args.mostRecent,
        "snapshotType": args.snapshotType,
        "tags": args.tags,
    }, opts);
}
exports.getClusterSnapshot = getClusterSnapshot;
//# sourceMappingURL=getClusterSnapshot.js.map