"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Use this data source to get the Account ID of the [AWS Redshift Service Account](http://docs.aws.amazon.com/redshift/latest/mgmt/db-auditing.html#db-auditing-enable-logging)
 * in a given region for the purpose of allowing Redshift to store audit data in S3.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const main = pulumi.output(aws.redshift.getServiceAccount({ async: true }));
 * const bucket = new aws.s3.Bucket("bucket", {
 *     forceDestroy: true,
 *     policy: pulumi.interpolate`{
 * 	"Version": "2008-10-17",
 * 	"Statement": [
 * 		{
 *             "Sid": "Put bucket policy needed for audit logging",
 *             "Effect": "Allow",
 *             "Principal": {
 * 		        "AWS": "${main.arn}"
 *             },
 *             "Action": "s3:PutObject",
 *             "Resource": "arn:aws:s3:::tf-redshift-logging-test-bucket/*"
 *         },
 *         {
 *             "Sid": "Get bucket policy needed for audit logging ",
 *             "Effect": "Allow",
 *             "Principal": {
 * 		        "AWS": "${main.arn}"
 *             },
 *             "Action": "s3:GetBucketAcl",
 *             "Resource": "arn:aws:s3:::tf-redshift-logging-test-bucket"
 *         }
 * 	]
 * }
 * `,
 * });
 * ```
 */
function getServiceAccount(args, opts) {
    args = args || {};
    if (!opts) {
        opts = {};
    }
    if (!opts.version) {
        opts.version = utilities.getVersion();
    }
    return pulumi.runtime.invoke("aws:redshift/getServiceAccount:getServiceAccount", {
        "region": args.region,
    }, opts);
}
exports.getServiceAccount = getServiceAccount;
//# sourceMappingURL=getServiceAccount.js.map