"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Creates a snapshot copy grant that allows AWS Redshift to encrypt copied snapshots with a customer master key from AWS KMS in a destination region.
 *
 * Note that the grant must exist in the destination region, and not in the region of the cluster.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const testSnapshotCopyGrant = new aws.redshift.SnapshotCopyGrant("testSnapshotCopyGrant", {snapshotCopyGrantName: "my-grant"});
 * const testCluster = new aws.redshift.Cluster("testCluster", {snapshotCopy: {
 *     destinationRegion: "us-east-2",
 *     grantName: testSnapshotCopyGrant.snapshotCopyGrantName,
 * }});
 * ```
 *
 * ## Import
 *
 * Redshift Snapshot Copy Grants support import by name, e.g. console
 *
 * ```sh
 *  $ pulumi import aws:redshift/snapshotCopyGrant:SnapshotCopyGrant test my-grant
 * ```
 */
class SnapshotCopyGrant extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["arn"] = state ? state.arn : undefined;
            inputs["kmsKeyId"] = state ? state.kmsKeyId : undefined;
            inputs["snapshotCopyGrantName"] = state ? state.snapshotCopyGrantName : undefined;
            inputs["tags"] = state ? state.tags : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.snapshotCopyGrantName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'snapshotCopyGrantName'");
            }
            inputs["kmsKeyId"] = args ? args.kmsKeyId : undefined;
            inputs["snapshotCopyGrantName"] = args ? args.snapshotCopyGrantName : undefined;
            inputs["tags"] = args ? args.tags : undefined;
            inputs["arn"] = undefined /*out*/;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(SnapshotCopyGrant.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing SnapshotCopyGrant resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new SnapshotCopyGrant(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of SnapshotCopyGrant.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === SnapshotCopyGrant.__pulumiType;
    }
}
exports.SnapshotCopyGrant = SnapshotCopyGrant;
/** @internal */
SnapshotCopyGrant.__pulumiType = 'aws:redshift/snapshotCopyGrant:SnapshotCopyGrant';
//# sourceMappingURL=snapshotCopyGrant.js.map