"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * `aws.route53.Zone` provides details about a specific Route 53 Hosted Zone.
 *
 * This data source allows to find a Hosted Zone ID given Hosted Zone name and certain search criteria.
 *
 * ## Example Usage
 *
 * The following example shows how to get a Hosted Zone from its name and from this data how to create a Record Set.
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const selected = aws.route53.getZone({
 *     name: "test.com.",
 *     privateZone: true,
 * });
 * const www = new aws.route53.Record("www", {
 *     zoneId: selected.then(selected => selected.zoneId),
 *     name: selected.then(selected => `www.${selected.name}`),
 *     type: "A",
 *     ttl: "300",
 *     records: ["10.0.0.1"],
 * });
 * ```
 */
function getZone(args, opts) {
    args = args || {};
    if (!opts) {
        opts = {};
    }
    if (!opts.version) {
        opts.version = utilities.getVersion();
    }
    return pulumi.runtime.invoke("aws:route53/getZone:getZone", {
        "name": args.name,
        "privateZone": args.privateZone,
        "resourceRecordSetCount": args.resourceRecordSetCount,
        "tags": args.tags,
        "vpcId": args.vpcId,
        "zoneId": args.zoneId,
    }, opts);
}
exports.getZone = getZone;
//# sourceMappingURL=getZone.js.map