"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * > **NOTE on `maxKeys`:** Retrieving very large numbers of keys can adversely affect this provider's performance.
 *
 * The bucket-objects data source returns keys (i.e., file names) and other metadata about objects in an S3 bucket.
 *
 * ## Example Usage
 *
 * The following example retrieves a list of all object keys in an S3 bucket and creates corresponding object data sources:
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const myObjects = aws.s3.getBucketObjects({
 *     bucket: "ourcorp",
 * });
 * const objectInfo = .map(__index => aws.s3.getBucketObject({
 *     key: _arg0_,
 *     bucket: _arg1_.bucket,
 * }));
 * ```
 */
function getBucketObjects(args, opts) {
    if (!opts) {
        opts = {};
    }
    if (!opts.version) {
        opts.version = utilities.getVersion();
    }
    return pulumi.runtime.invoke("aws:s3/getBucketObjects:getBucketObjects", {
        "bucket": args.bucket,
        "delimiter": args.delimiter,
        "encodingType": args.encodingType,
        "fetchOwner": args.fetchOwner,
        "maxKeys": args.maxKeys,
        "prefix": args.prefix,
        "startAfter": args.startAfter,
    }, opts);
}
exports.getBucketObjects = getBucketObjects;
//# sourceMappingURL=getBucketObjects.js.map