"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides a Sagemaker App resource.
 *
 * ## Example Usage
 * ### Basic usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = new aws.sagemaker.App("example", {
 *     domainId: aws_sagemaker_domain.example.id,
 *     userProfileName: aws_sagemaker_user_profile.example.user_profile_name,
 *     appName: "example",
 *     appType: "JupyterServer",
 * });
 * ```
 *
 * ## Import
 *
 * Sagemaker Code Apps can be imported using the `id`, e.g.
 *
 * ```sh
 *  $ pulumi import aws:sagemaker/app:App example arn:aws:sagemaker:us-west-2:012345678912:app/domain-id/user-profile-name/app-type/app-name
 * ```
 */
class App extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["appName"] = state ? state.appName : undefined;
            inputs["appType"] = state ? state.appType : undefined;
            inputs["arn"] = state ? state.arn : undefined;
            inputs["domainId"] = state ? state.domainId : undefined;
            inputs["resourceSpec"] = state ? state.resourceSpec : undefined;
            inputs["tags"] = state ? state.tags : undefined;
            inputs["userProfileName"] = state ? state.userProfileName : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.appName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'appName'");
            }
            if ((!args || args.appType === undefined) && !opts.urn) {
                throw new Error("Missing required property 'appType'");
            }
            if ((!args || args.domainId === undefined) && !opts.urn) {
                throw new Error("Missing required property 'domainId'");
            }
            if ((!args || args.userProfileName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'userProfileName'");
            }
            inputs["appName"] = args ? args.appName : undefined;
            inputs["appType"] = args ? args.appType : undefined;
            inputs["domainId"] = args ? args.domainId : undefined;
            inputs["resourceSpec"] = args ? args.resourceSpec : undefined;
            inputs["tags"] = args ? args.tags : undefined;
            inputs["userProfileName"] = args ? args.userProfileName : undefined;
            inputs["arn"] = undefined /*out*/;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(App.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing App resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new App(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of App.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === App.__pulumiType;
    }
}
exports.App = App;
/** @internal */
App.__pulumiType = 'aws:sagemaker/app:App';
//# sourceMappingURL=app.js.map