"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Retrieve information about a Secrets Manager secret version, including its secret value. To retrieve secret metadata, see the `aws.secretsmanager.Secret` data source.
 *
 * ## Example Usage
 * ### Retrieve Current Secret Version
 *
 * By default, this data sources retrieves information based on the `AWSCURRENT` staging label.
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = aws.secretsmanager.getSecretVersion({
 *     secretId: data.aws_secretsmanager_secret.example.id,
 * });
 * ```
 * ### Retrieve Specific Secret Version
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const by-version-stage = aws.secretsmanager.getSecretVersion({
 *     secretId: data.aws_secretsmanager_secret.example.id,
 *     versionStage: "example",
 * });
 * ```
 */
function getSecretVersion(args, opts) {
    if (!opts) {
        opts = {};
    }
    if (!opts.version) {
        opts.version = utilities.getVersion();
    }
    return pulumi.runtime.invoke("aws:secretsmanager/getSecretVersion:getSecretVersion", {
        "secretId": args.secretId,
        "versionId": args.versionId,
        "versionStage": args.versionStage,
    }, opts);
}
exports.getSecretVersion = getSecretVersion;
//# sourceMappingURL=getSecretVersion.js.map