"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * > **Note:** AWS accounts can only be associated with a single Security Hub master account. Destroying this resource will disassociate the member account from the master account.
 *
 * Accepts a Security Hub invitation.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const exampleAccount = new aws.securityhub.Account("exampleAccount", {});
 * const exampleMember = new aws.securityhub.Member("exampleMember", {
 *     accountId: "123456789012",
 *     email: "example@example.com",
 *     invite: true,
 * });
 * const inviteeAccount = new aws.securityhub.Account("inviteeAccount", {}, {
 *     provider: "aws.invitee",
 * });
 * const inviteeInviteAccepter = new aws.securityhub.InviteAccepter("inviteeInviteAccepter", {masterId: exampleMember.masterId}, {
 *     provider: "aws.invitee",
 *     dependsOn: [aws_securityhub_account.accepter],
 * });
 * ```
 *
 * ## Import
 *
 * Security Hub invite acceptance can be imported using the account ID, e.g.
 *
 * ```sh
 *  $ pulumi import aws:securityhub/inviteAccepter:InviteAccepter example 123456789012
 * ```
 */
class InviteAccepter extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["invitationId"] = state ? state.invitationId : undefined;
            inputs["masterId"] = state ? state.masterId : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.masterId === undefined) && !opts.urn) {
                throw new Error("Missing required property 'masterId'");
            }
            inputs["masterId"] = args ? args.masterId : undefined;
            inputs["invitationId"] = undefined /*out*/;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(InviteAccepter.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing InviteAccepter resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new InviteAccepter(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of InviteAccepter.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === InviteAccepter.__pulumiType;
    }
}
exports.InviteAccepter = InviteAccepter;
/** @internal */
InviteAccepter.__pulumiType = 'aws:securityhub/inviteAccepter:InviteAccepter';
//# sourceMappingURL=inviteAccepter.js.map