"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides an SES receipt rule resource
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * // Add a header to the email and store it in S3
 * const store = new aws.ses.ReceiptRule("store", {
 *     addHeaderActions: [{
 *         headerName: "Custom-Header",
 *         headerValue: "Added by SES",
 *         position: 1,
 *     }],
 *     enabled: true,
 *     recipients: ["karen@example.com"],
 *     ruleSetName: "default-rule-set",
 *     s3Actions: [{
 *         bucketName: "emails",
 *         position: 2,
 *     }],
 *     scanEnabled: true,
 * });
 * ```
 *
 * ## Import
 *
 * SES receipt rules can be imported using the ruleset name and rule name separated by `:`.
 *
 * ```sh
 *  $ pulumi import aws:ses/receiptRule:ReceiptRule my_rule my_rule_set:my_rule
 * ```
 */
class ReceiptRule extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["addHeaderActions"] = state ? state.addHeaderActions : undefined;
            inputs["after"] = state ? state.after : undefined;
            inputs["arn"] = state ? state.arn : undefined;
            inputs["bounceActions"] = state ? state.bounceActions : undefined;
            inputs["enabled"] = state ? state.enabled : undefined;
            inputs["lambdaActions"] = state ? state.lambdaActions : undefined;
            inputs["name"] = state ? state.name : undefined;
            inputs["recipients"] = state ? state.recipients : undefined;
            inputs["ruleSetName"] = state ? state.ruleSetName : undefined;
            inputs["s3Actions"] = state ? state.s3Actions : undefined;
            inputs["scanEnabled"] = state ? state.scanEnabled : undefined;
            inputs["snsActions"] = state ? state.snsActions : undefined;
            inputs["stopActions"] = state ? state.stopActions : undefined;
            inputs["tlsPolicy"] = state ? state.tlsPolicy : undefined;
            inputs["workmailActions"] = state ? state.workmailActions : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.ruleSetName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'ruleSetName'");
            }
            inputs["addHeaderActions"] = args ? args.addHeaderActions : undefined;
            inputs["after"] = args ? args.after : undefined;
            inputs["bounceActions"] = args ? args.bounceActions : undefined;
            inputs["enabled"] = args ? args.enabled : undefined;
            inputs["lambdaActions"] = args ? args.lambdaActions : undefined;
            inputs["name"] = args ? args.name : undefined;
            inputs["recipients"] = args ? args.recipients : undefined;
            inputs["ruleSetName"] = args ? args.ruleSetName : undefined;
            inputs["s3Actions"] = args ? args.s3Actions : undefined;
            inputs["scanEnabled"] = args ? args.scanEnabled : undefined;
            inputs["snsActions"] = args ? args.snsActions : undefined;
            inputs["stopActions"] = args ? args.stopActions : undefined;
            inputs["tlsPolicy"] = args ? args.tlsPolicy : undefined;
            inputs["workmailActions"] = args ? args.workmailActions : undefined;
            inputs["arn"] = undefined /*out*/;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(ReceiptRule.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing ReceiptRule resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new ReceiptRule(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of ReceiptRule.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === ReceiptRule.__pulumiType;
    }
}
exports.ReceiptRule = ReceiptRule;
/** @internal */
ReceiptRule.__pulumiType = 'aws:ses/receiptRule:ReceiptRule';
//# sourceMappingURL=receiptRule.js.map