"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Creates a Signer Signing Job.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const testSp = new aws.signer.SigningProfile("testSp", {platformId: "AWSLambda-SHA384-ECDSA"});
 * const buildSigningJob = new aws.signer.SigningJob("buildSigningJob", {
 *     profileName: testSp.name,
 *     source: {
 *         s3: {
 *             bucket: "s3-bucket-name",
 *             key: "object-to-be-signed.zip",
 *             version: "jADjFYYYEXAMPLETszPjOmCMFDzd9dN1",
 *         },
 *     },
 *     destination: {
 *         s3: {
 *             bucket: "s3-bucket-name",
 *             prefix: "signed/",
 *         },
 *     },
 *     ignoreSigningJobFailure: true,
 * });
 * ```
 *
 * ## Import
 *
 * Signer signing jobs can be imported using the `job_id`, e.g.
 *
 * ```sh
 *  $ pulumi import aws:signer/signingJob:SigningJob test_signer_signing_job 9ed7e5c3-b8d4-4da0-8459-44e0b068f7ee
 * ```
 */
class SigningJob extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["completedAt"] = state ? state.completedAt : undefined;
            inputs["createdAt"] = state ? state.createdAt : undefined;
            inputs["destination"] = state ? state.destination : undefined;
            inputs["ignoreSigningJobFailure"] = state ? state.ignoreSigningJobFailure : undefined;
            inputs["jobId"] = state ? state.jobId : undefined;
            inputs["jobInvoker"] = state ? state.jobInvoker : undefined;
            inputs["jobOwner"] = state ? state.jobOwner : undefined;
            inputs["platformDisplayName"] = state ? state.platformDisplayName : undefined;
            inputs["platformId"] = state ? state.platformId : undefined;
            inputs["profileName"] = state ? state.profileName : undefined;
            inputs["profileVersion"] = state ? state.profileVersion : undefined;
            inputs["requestedBy"] = state ? state.requestedBy : undefined;
            inputs["revocationRecords"] = state ? state.revocationRecords : undefined;
            inputs["signatureExpiresAt"] = state ? state.signatureExpiresAt : undefined;
            inputs["signedObjects"] = state ? state.signedObjects : undefined;
            inputs["source"] = state ? state.source : undefined;
            inputs["status"] = state ? state.status : undefined;
            inputs["statusReason"] = state ? state.statusReason : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.destination === undefined) && !opts.urn) {
                throw new Error("Missing required property 'destination'");
            }
            if ((!args || args.profileName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'profileName'");
            }
            if ((!args || args.source === undefined) && !opts.urn) {
                throw new Error("Missing required property 'source'");
            }
            inputs["destination"] = args ? args.destination : undefined;
            inputs["ignoreSigningJobFailure"] = args ? args.ignoreSigningJobFailure : undefined;
            inputs["profileName"] = args ? args.profileName : undefined;
            inputs["source"] = args ? args.source : undefined;
            inputs["completedAt"] = undefined /*out*/;
            inputs["createdAt"] = undefined /*out*/;
            inputs["jobId"] = undefined /*out*/;
            inputs["jobInvoker"] = undefined /*out*/;
            inputs["jobOwner"] = undefined /*out*/;
            inputs["platformDisplayName"] = undefined /*out*/;
            inputs["platformId"] = undefined /*out*/;
            inputs["profileVersion"] = undefined /*out*/;
            inputs["requestedBy"] = undefined /*out*/;
            inputs["revocationRecords"] = undefined /*out*/;
            inputs["signatureExpiresAt"] = undefined /*out*/;
            inputs["signedObjects"] = undefined /*out*/;
            inputs["status"] = undefined /*out*/;
            inputs["statusReason"] = undefined /*out*/;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(SigningJob.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing SigningJob resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new SigningJob(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of SigningJob.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === SigningJob.__pulumiType;
    }
}
exports.SigningJob = SigningJob;
/** @internal */
SigningJob.__pulumiType = 'aws:signer/signingJob:SigningJob';
//# sourceMappingURL=signingJob.js.map