"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Gets the contents of the specified Systems Manager document.
 *
 * ## Example Usage
 *
 * To get the contents of the document owned by AWS.
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const foo = aws.ssm.getDocument({
 *     name: "AWS-GatherSoftwareInventory",
 *     documentFormat: "YAML",
 * });
 * export const content = foo.then(foo => foo.content);
 * ```
 *
 * To get the contents of the custom document.
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const test = aws.ssm.getDocument({
 *     name: aws_ssm_document.test.name,
 *     documentFormat: "JSON",
 * });
 * ```
 */
function getDocument(args, opts) {
    if (!opts) {
        opts = {};
    }
    if (!opts.version) {
        opts.version = utilities.getVersion();
    }
    return pulumi.runtime.invoke("aws:ssm/getDocument:getDocument", {
        "documentFormat": args.documentFormat,
        "documentVersion": args.documentVersion,
        "name": args.name,
    }, opts);
}
exports.getDocument = getDocument;
//# sourceMappingURL=getDocument.js.map