"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides an SSM Patch Baseline data source. Useful if you wish to reuse the default baselines provided.
 *
 * ## Example Usage
 *
 * To retrieve a baseline provided by AWS:
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const centos = pulumi.output(aws.ssm.getPatchBaseline({
 *     namePrefix: "AWS-",
 *     operatingSystem: "CENTOS",
 *     owner: "AWS",
 * }, { async: true }));
 * ```
 *
 * To retrieve a baseline on your account:
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const defaultCustom = pulumi.output(aws.ssm.getPatchBaseline({
 *     defaultBaseline: true,
 *     namePrefix: "MyCustomBaseline",
 *     operatingSystem: "WINDOWS",
 *     owner: "Self",
 * }, { async: true }));
 * ```
 */
function getPatchBaseline(args, opts) {
    if (!opts) {
        opts = {};
    }
    if (!opts.version) {
        opts.version = utilities.getVersion();
    }
    return pulumi.runtime.invoke("aws:ssm/getPatchBaseline:getPatchBaseline", {
        "defaultBaseline": args.defaultBaseline,
        "namePrefix": args.namePrefix,
        "operatingSystem": args.operatingSystem,
        "owner": args.owner,
    }, opts);
}
exports.getPatchBaseline = getPatchBaseline;
//# sourceMappingURL=getPatchBaseline.js.map