"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides an SSM Patch Group resource
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const production = new aws.ssm.PatchBaseline("production", {approvedPatches: ["KB123456"]});
 * const patchgroup = new aws.ssm.PatchGroup("patchgroup", {
 *     baselineId: production.id,
 *     patchGroup: "patch-group-name",
 * });
 * ```
 */
class PatchGroup extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["baselineId"] = state ? state.baselineId : undefined;
            inputs["patchGroup"] = state ? state.patchGroup : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.baselineId === undefined) && !opts.urn) {
                throw new Error("Missing required property 'baselineId'");
            }
            if ((!args || args.patchGroup === undefined) && !opts.urn) {
                throw new Error("Missing required property 'patchGroup'");
            }
            inputs["baselineId"] = args ? args.baselineId : undefined;
            inputs["patchGroup"] = args ? args.patchGroup : undefined;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(PatchGroup.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing PatchGroup resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new PatchGroup(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of PatchGroup.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === PatchGroup.__pulumiType;
    }
}
exports.PatchGroup = PatchGroup;
/** @internal */
PatchGroup.__pulumiType = 'aws:ssm/patchGroup:PatchGroup';
//# sourceMappingURL=patchGroup.js.map