"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides a SSM resource data sync.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const hogeBucket = new aws.s3.Bucket("hogeBucket", {});
 * const hogeBucketPolicy = new aws.s3.BucketPolicy("hogeBucketPolicy", {
 *     bucket: hogeBucket.bucket,
 *     policy: `{
 *     "Version": "2012-10-17",
 *     "Statement": [
 *         {
 *             "Sid": "SSMBucketPermissionsCheck",
 *             "Effect": "Allow",
 *             "Principal": {
 *                 "Service": "ssm.amazonaws.com"
 *             },
 *             "Action": "s3:GetBucketAcl",
 *             "Resource": "arn:aws:s3:::tf-test-bucket-1234"
 *         },
 *         {
 *             "Sid": " SSMBucketDelivery",
 *             "Effect": "Allow",
 *             "Principal": {
 *                 "Service": "ssm.amazonaws.com"
 *             },
 *             "Action": "s3:PutObject",
 *             "Resource": ["arn:aws:s3:::tf-test-bucket-1234/*"],
 *             "Condition": {
 *                 "StringEquals": {
 *                     "s3:x-amz-acl": "bucket-owner-full-control"
 *                 }
 *             }
 *         }
 *     ]
 * }
 * `,
 * });
 * const foo = new aws.ssm.ResourceDataSync("foo", {s3Destination: {
 *     bucketName: hogeBucket.bucket,
 *     region: hogeBucket.region,
 * }});
 * ```
 *
 * ## Import
 *
 * SSM resource data sync can be imported using the `name`, e.g.
 *
 * ```sh
 *  $ pulumi import aws:ssm/resourceDataSync:ResourceDataSync example example-name
 * ```
 */
class ResourceDataSync extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["name"] = state ? state.name : undefined;
            inputs["s3Destination"] = state ? state.s3Destination : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.s3Destination === undefined) && !opts.urn) {
                throw new Error("Missing required property 's3Destination'");
            }
            inputs["name"] = args ? args.name : undefined;
            inputs["s3Destination"] = args ? args.s3Destination : undefined;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(ResourceDataSync.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing ResourceDataSync resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new ResourceDataSync(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of ResourceDataSync.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === ResourceDataSync.__pulumiType;
    }
}
exports.ResourceDataSync = ResourceDataSync;
/** @internal */
ResourceDataSync.__pulumiType = 'aws:ssm/resourceDataSync:ResourceDataSync';
//# sourceMappingURL=resourceDataSync.js.map