import * as pulumi from "@pulumi/pulumi";
/**
 * Use this data source to get ARNs and Identity Store IDs of Single Sign-On (SSO) Instances.
 */
export declare function getInstances(opts?: pulumi.InvokeOptions): Promise<GetInstancesResult>;
/**
 * A collection of values returned by getInstances.
 */
export interface GetInstancesResult {
    /**
     * Set of Amazon Resource Names (ARNs) of the SSO Instances.
     */
    readonly arns: string[];
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * Set of identifiers of the identity stores connected to the SSO Instances.
     */
    readonly identityStoreIds: string[];
}
