export declare const Metric: {
    readonly GroupMinSize: "GroupMinSize";
    readonly GroupMaxSize: "GroupMaxSize";
    readonly GroupDesiredCapacity: "GroupDesiredCapacity";
    readonly GroupInServiceInstances: "GroupInServiceInstances";
    readonly GroupInServiceCapacity: "GroupInServiceCapacity";
    readonly GroupPendingInstances: "GroupPendingInstances";
    readonly GroupPendingCapacity: "GroupPendingCapacity";
    readonly GroupStandbyInstances: "GroupStandbyInstances";
    readonly GroupStandbyCapacity: "GroupStandbyCapacity";
    readonly GroupTerminatingInstances: "GroupTerminatingInstances";
    readonly GroupTerminatingCapacity: "GroupTerminatingCapacity";
    readonly GroupTotalInstances: "GroupTotalInstances";
    readonly GroupTotalCapacity: "GroupTotalCapacity";
};
/**
 * See https://docs.aws.amazon.com/autoscaling/ec2/APIReference/API_EnableMetricsCollection.html
 */
export declare type Metric = (typeof Metric)[keyof typeof Metric];
export declare const MetricsGranularity: {
    readonly OneMinute: "1Minute";
};
/**
 * See https://docs.aws.amazon.com/autoscaling/ec2/APIReference/API_EnableMetricsCollection.html
 */
export declare type MetricsGranularity = (typeof MetricsGranularity)[keyof typeof MetricsGranularity];
export declare const NotificationType: {
    readonly InstanceLaunch: "autoscaling:EC2_INSTANCE_LAUNCH";
    readonly InstanceTerminate: "autoscaling:EC2_INSTANCE_TERMINATE";
    readonly InstanceLaunchError: "autoscaling:EC2_INSTANCE_LAUNCH_ERROR";
    readonly InstanceTerminateError: "autoscaling:EC2_INSTANCE_TERMINATE_ERROR";
    readonly TestNotification: "autoscaling:TEST_NOTIFICATION";
};
/**
 * See https://docs.aws.amazon.com/autoscaling/ec2/APIReference/API_NotificationConfiguration.html
 */
export declare type NotificationType = (typeof NotificationType)[keyof typeof NotificationType];
