import * as pulumi from "@pulumi/pulumi";
/**
 * `aws.waf.RateBasedRule` Retrieves a WAF Rate Based Rule Resource Id.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = pulumi.output(aws.waf.getRateBasedRule({
 *     name: "tfWAFRateBasedRule",
 * }, { async: true }));
 * ```
 */
export declare function getRateBasedRule(args: GetRateBasedRuleArgs, opts?: pulumi.InvokeOptions): Promise<GetRateBasedRuleResult>;
/**
 * A collection of arguments for invoking getRateBasedRule.
 */
export interface GetRateBasedRuleArgs {
    /**
     * The name of the WAF rate based rule.
     */
    readonly name: string;
}
/**
 * A collection of values returned by getRateBasedRule.
 */
export interface GetRateBasedRuleResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    readonly name: string;
}
