import * as pulumi from "@pulumi/pulumi";
/**
 * `aws.wafregional.IpSet` Retrieves a WAF Regional IP Set Resource Id.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = pulumi.output(aws.wafregional.getIpset({
 *     name: "tfWAFRegionalIPSet",
 * }, { async: true }));
 * ```
 */
export declare function getIpset(args: GetIpsetArgs, opts?: pulumi.InvokeOptions): Promise<GetIpsetResult>;
/**
 * A collection of arguments for invoking getIpset.
 */
export interface GetIpsetArgs {
    /**
     * The name of the WAF Regional IP set.
     */
    readonly name: string;
}
/**
 * A collection of values returned by getIpset.
 */
export interface GetIpsetResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    readonly name: string;
}
