import * as pulumi from "@pulumi/pulumi";
/**
 * `aws.wafregional.RateBasedRule` Retrieves a WAF Regional Rate Based Rule Resource Id.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = pulumi.output(aws.wafregional.getRateBasedMod({
 *     name: "tfWAFRegionalRateBasedRule",
 * }, { async: true }));
 * ```
 */
export declare function getRateBasedMod(args: GetRateBasedModArgs, opts?: pulumi.InvokeOptions): Promise<GetRateBasedModResult>;
/**
 * A collection of arguments for invoking getRateBasedMod.
 */
export interface GetRateBasedModArgs {
    /**
     * The name of the WAF Regional rate based rule.
     */
    readonly name: string;
}
/**
 * A collection of values returned by getRateBasedMod.
 */
export interface GetRateBasedModResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    readonly name: string;
}
