import * as pulumi from "@pulumi/pulumi";
/**
 * `aws.wafregional.WebAcl` Retrieves a WAF Regional Web ACL Resource Id.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = pulumi.output(aws.wafregional.getWebAcl({
 *     name: "tfWAFRegionalWebACL",
 * }, { async: true }));
 * ```
 */
export declare function getWebAcl(args: GetWebAclArgs, opts?: pulumi.InvokeOptions): Promise<GetWebAclResult>;
/**
 * A collection of arguments for invoking getWebAcl.
 */
export interface GetWebAclArgs {
    /**
     * The name of the WAF Regional Web ACL.
     */
    readonly name: string;
}
/**
 * A collection of values returned by getWebAcl.
 */
export interface GetWebAclResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    readonly name: string;
}
