"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides a WAF Regional XSS Match Set Resource for use with Application Load Balancer.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const xssMatchSet = new aws.wafregional.XssMatchSet("xss_match_set", {
 *     xssMatchTuples: [
 *         {
 *             fieldToMatch: {
 *                 type: "URI",
 *             },
 *             textTransformation: "NONE",
 *         },
 *         {
 *             fieldToMatch: {
 *                 type: "QUERY_STRING",
 *             },
 *             textTransformation: "NONE",
 *         },
 *     ],
 * });
 * ```
 *
 * ## Import
 *
 * AWS WAF Regional XSS Match can be imported using the `id`, e.g.
 *
 * ```sh
 *  $ pulumi import aws:wafregional/xssMatchSet:XssMatchSet example 12345abcde
 * ```
 */
class XssMatchSet extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["name"] = state ? state.name : undefined;
            inputs["xssMatchTuples"] = state ? state.xssMatchTuples : undefined;
        }
        else {
            const args = argsOrState;
            inputs["name"] = args ? args.name : undefined;
            inputs["xssMatchTuples"] = args ? args.xssMatchTuples : undefined;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(XssMatchSet.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing XssMatchSet resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new XssMatchSet(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of XssMatchSet.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === XssMatchSet.__pulumiType;
    }
}
exports.XssMatchSet = XssMatchSet;
/** @internal */
XssMatchSet.__pulumiType = 'aws:wafregional/xssMatchSet:XssMatchSet';
//# sourceMappingURL=xssMatchSet.js.map