"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * ## Example Usage
 *
 * Basic usage:
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = new aws.worklink.Fleet("example", {});
 * ```
 *
 * Network Configuration Usage:
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 *
 * const example = new aws.worklink.Fleet("example", {network: {
 *     vpcId: aws_vpc.test.id,
 *     subnetIds: [aws_subnet.test.map(__item => __item.id)],
 *     securityGroupIds: [aws_security_group.test.id],
 * }});
 * ```
 *
 * Identity Provider Configuration Usage:
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as aws from "@pulumi/aws";
 * import * from "fs";
 *
 * const test = new aws.worklink.Fleet("test", {identityProvider: {
 *     type: "SAML",
 *     samlMetadata: fs.readFileSync("saml-metadata.xml"),
 * }});
 * ```
 *
 * ## Import
 *
 * WorkLink can be imported using the ARN, e.g.
 *
 * ```sh
 *  $ pulumi import aws:worklink/fleet:Fleet test arn:aws:worklink::123456789012:fleet/example
 * ```
 */
class Fleet extends pulumi.CustomResource {
    constructor(name, argsOrState, opts) {
        let inputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            inputs["arn"] = state ? state.arn : undefined;
            inputs["auditStreamArn"] = state ? state.auditStreamArn : undefined;
            inputs["companyCode"] = state ? state.companyCode : undefined;
            inputs["createdTime"] = state ? state.createdTime : undefined;
            inputs["deviceCaCertificate"] = state ? state.deviceCaCertificate : undefined;
            inputs["displayName"] = state ? state.displayName : undefined;
            inputs["identityProvider"] = state ? state.identityProvider : undefined;
            inputs["lastUpdatedTime"] = state ? state.lastUpdatedTime : undefined;
            inputs["name"] = state ? state.name : undefined;
            inputs["network"] = state ? state.network : undefined;
            inputs["optimizeForEndUserLocation"] = state ? state.optimizeForEndUserLocation : undefined;
        }
        else {
            const args = argsOrState;
            inputs["auditStreamArn"] = args ? args.auditStreamArn : undefined;
            inputs["deviceCaCertificate"] = args ? args.deviceCaCertificate : undefined;
            inputs["displayName"] = args ? args.displayName : undefined;
            inputs["identityProvider"] = args ? args.identityProvider : undefined;
            inputs["name"] = args ? args.name : undefined;
            inputs["network"] = args ? args.network : undefined;
            inputs["optimizeForEndUserLocation"] = args ? args.optimizeForEndUserLocation : undefined;
            inputs["arn"] = undefined /*out*/;
            inputs["companyCode"] = undefined /*out*/;
            inputs["createdTime"] = undefined /*out*/;
            inputs["lastUpdatedTime"] = undefined /*out*/;
        }
        if (!opts.version) {
            opts = pulumi.mergeOptions(opts, { version: utilities.getVersion() });
        }
        super(Fleet.__pulumiType, name, inputs, opts);
    }
    /**
     * Get an existing Fleet resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new Fleet(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of Fleet.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Fleet.__pulumiType;
    }
}
exports.Fleet = Fleet;
/** @internal */
Fleet.__pulumiType = 'aws:worklink/fleet:Fleet';
//# sourceMappingURL=fleet.js.map